/*
    artifact generator: C:\My\wizzi\v5\apps\node_modules\wizzi-js\lib\artifacts\js\module\gen\main.js
    primary source IttfDocument: c:\my\wizzi\v5\apps\wizzi-tools\src\ittf\lib\wizzifiers\jsparser\babel\wizzifier.js.ittf
    utc time: Sun, 16 Sep 2018 13:21:26 GMT
*/
'use strict';
var util = require('util');
var path = require('path');
var file = require('wizzi-utils').file;
var verify = require('wizzi-utils').verify;
var parser = require("@babel/parser");
var ittfwriter = require("../../../util/ittfwriter");
var cleanBabel = require('./cleanBabel');
var format = function(parent, ast, options) {
    if (!ast) {
        throw new Error('missing ast. parent is: ' + util.inspect(parent, { depth: 2 }));
    }
    if (parent === null) {
        if (options.starter) {
            options.starter = false;
        }
        else if (options.returnText) {
            // ok
        }
        else {
            showstack(options);
            throw new Error('parent is null.' + util.inspect(ast, 4));
        }
    }
    if (options.verbose) {
        console.log('ast.type', ast.type);
    }
    var formatter = format[ast.type];
    if (formatter) {
        options.stack.push(ast);
        var result = formatter(parent, ast, options);
        options.stack.pop();
        return result;
    }
    else {
        throw new Error('no formatter for type: ' + ast.type);
    }
};
var formatText = function(parent, ast, options, node) {
    var saveReturnText = options.returnText;
    options.returnText = true;
    if (node) {
        options.formatTextNodes.push(node);
    }
    var value = format(parent, ast, options);
    if (node) {
        options.formatTextNodes.pop();
    }
    options.returnText = saveReturnText;
    return value;
};
// process AST node File
format.File = function(parent, node, options) {
    console.log('node : File ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = parent;
    // process AST-node-property program and append ittfNode to `ret`
    if (node.program) {
        if (!node.program.type) {
            throw 'Node program has no type: ' + JSON.stringify(node);
        }
        format(ret, node.program, options);
    }
    else {
        throw new Error('AST-node-property program undefined: ' + JSON.stringify(node));
    }
    // process AST-node-property-collection comments and append ittfNode(s) to `ret`
    if (node.comments) {
        if (typeof node.comments.length === 'undefined') {
            throw new Error('Property node.comments must be an array');
        }
        var i, i_items=node.comments, i_len=node.comments.length, item;
        for (i=0; i<i_len; i++) {
            item = node.comments[i];
            item.__parent = {
                name: 'comments', 
                len: node.comments.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection comments undefined: ' + JSON.stringify(node));
    }
    if (ret != null) {
    }
};
// process AST node Program
format.Program = function(parent, node, options) {
    console.log('node : Program ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = parent;
    // s( sourceType, "script" | "module"
    // process AST-node-property-collection directives and append ittfNode(s) to `ret`
    if (node.directives) {
        if (typeof node.directives.length === 'undefined') {
            throw new Error('Property node.directives must be an array');
        }
        var i, i_items=node.directives, i_len=node.directives.length, item;
        for (i=0; i<i_len; i++) {
            item = node.directives[i];
            item.__parent = {
                name: 'directives', 
                len: node.directives.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection directives undefined: ' + JSON.stringify(node));
    }
    // process AST-node-property-collection body and append ittfNode(s) to `ret`
    if (node.body) {
        if (typeof node.body.length === 'undefined') {
            throw new Error('Property node.body must be an array');
        }
        var i, i_items=node.body, i_len=node.body.length, item;
        for (i=0; i<i_len; i++) {
            item = node.body[i];
            item.__parent = {
                name: 'body', 
                len: node.body.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection body undefined: ' + JSON.stringify(node));
    }
    if (ret != null) {
    }
};
// process AST node Identifier
format.Identifier = function(parent, node, options) {
    console.log('node : Identifier ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'ident', 
        name: '', 
        isText: true, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // log 't/name.node.name, value: ', node.name, '
    if (typeof node.name !== 'undefined') {
        ret.name = node.name.toString();
    }
    // log 't/name ittf.ret', ret
    // An identifier. Note that an identifier may be an expression or a destructuring pattern.
    if (node.__parent && node.__parent.name === 'body' && node.__parent.len == 1) {
        // is the return value of an ArrowExpression
        if (node.extra && node.extra.parenthesized == true) {
            ret.tag = '(';
        }
        else {
            ret.tag = '+';
        }
    }
    if (ret != null) {
        ret.textified = ret.name;
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node PrivateName
format.PrivateName = function(parent, node, options) {
    console.log('node : PrivateName ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Process AST-node-property Identifier and
    // set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.Identifier) {
        if (!node.Identifier.type) {
            throw 'Node Identifier has no type: ' + JSON.stringify(node);
        }
        var tempIdentifier = {
            children: [
                
            ]
        };
        format(tempIdentifier, node.Identifier, options);
        /**
            if (tempIdentifier .children.length > 0) {
                throw 'node.Identifier must result zero node, returned: ' + tempIdentifier.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempIdentifier.children.length > 0) {
            appto.name = tempIdentifier.children[0].name;
        }
        else {
            appto.name = tempIdentifier.name;
        }
    }
    // A Private Name Identifier.
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node RegExpLiteral
format.RegExpLiteral = function(parent, node, options) {
    console.log('node : RegExpLiteral ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'literal', 
        name: '', 
        isText: true, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    ret.name = '/' + node.pattern + '/';
    if (node.flags && node.flags.length > 0) {
        ret.name += node.flags;
        console.log('*************** RegExpLiteral.ret.name', ret.name);
    }
    if (node.__parent && node.__parent.name === 'body' && node.__parent.len == 1) {
        // is the return value of an ArrowExpression
        if (node.extra && node.extra.parenthesized == true) {
            ret.tag = '(';
        }
        else {
            ret.tag = '+';
        }
    }
    if (ret != null) {
        ret.textified = ret.name;
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node NullLiteral
format.NullLiteral = function(parent, node, options) {
    console.log('node : NullLiteral ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'literal', 
        name: '', 
        isText: true, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    ret.name = 'null';
    if (node.__parent && node.__parent.name === 'body' && node.__parent.len == 1) {
        // is the return value of an ArrowExpression
        if (node.extra && node.extra.parenthesized == true) {
            ret.tag = '(';
        }
        else {
            ret.tag = '+';
        }
    }
    if (ret != null) {
        ret.textified = ret.name;
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node StringLiteral
format.StringLiteral = function(parent, node, options) {
    console.log('node : StringLiteral ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'literal', 
        name: '', 
        isText: true, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    ret.name = node.extra.raw;
    if (node.__parent && node.__parent.name === 'body' && node.__parent.len == 1) {
        // is the return value of an ArrowExpression
        if (node.extra && node.extra.parenthesized == true) {
            ret.tag = '(';
        }
        else {
            ret.tag = '+';
        }
    }
    if (ret != null) {
        ret.textified = ret.name;
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node BooleanLiteral
format.BooleanLiteral = function(parent, node, options) {
    console.log('node : BooleanLiteral ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'literal', 
        name: '', 
        isText: true, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // log 't/name.node.value, value: ', node.value, '
    if (typeof node.value !== 'undefined') {
        ret.name = node.value.toString();
    }
    // log 't/name ittf.ret', ret
    if (node.__parent && node.__parent.name === 'body' && node.__parent.len == 1) {
        // is the return value of an ArrowExpression
        if (node.extra && node.extra.parenthesized == true) {
            ret.tag = '(';
        }
        else {
            ret.tag = '+';
        }
    }
    if (ret != null) {
        ret.textified = ret.name;
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node NumericLiteral
format.NumericLiteral = function(parent, node, options) {
    console.log('node : NumericLiteral ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'literal', 
        name: '', 
        isText: true, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // log 't/name.node.value, value: ', node.value, '
    if (typeof node.value !== 'undefined') {
        ret.name = node.value.toString();
    }
    // log 't/name ittf.ret', ret
    if (node.__parent && node.__parent.name === 'body' && node.__parent.len == 1) {
        // is the return value of an ArrowExpression
        if (node.extra && node.extra.parenthesized == true) {
            ret.tag = '(';
        }
        else {
            ret.tag = '+';
        }
    }
    if (ret != null) {
        ret.textified = ret.name;
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node Function
format.Function = function(parent, node, options) {
    console.log('node : Function ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'function', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A function [declaration](#functiondeclaration) or [expression](#functionexpression).
    // Process AST-node-property id and
    // set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.id) {
        if (!node.id.type) {
            throw 'Node id has no type: ' + JSON.stringify(node);
        }
        var tempid = {
            children: [
                
            ]
        };
        format(tempid, node.id, options);
        /**
            if (tempid .children.length > 0) {
                throw 'node.id must result zero node, returned: ' + tempid.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempid.children.length > 0) {
            appto.name = tempid.children[0].name;
        }
        else {
            appto.name = tempid.name;
        }
    }
    // process AST-node-property-collection params and
    // embed its array of nodes in a new tag
    if (node.params) {
        if (typeof node.params.length === 'undefined') {
            throw new Error('Property node.params must be an array');
        }
        if (node.params.length > 0) {
            var tempparams = {
                tag: 'params', 
                children: [
                    
                ]
            };
            var i, i_items=node.params, i_len=node.params.length, item;
            for (i=0; i<i_len; i++) {
                item = node.params[i];
                item.__parent = {
                    name: 'params', 
                    len: node.params.length
                };
                format(tempparams, item, options);
            }
            ret.children.push(tempparams);
        }
    }
    processParams(ret);
    // [ Pattern ]
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    // b( generator
    // b( async
    /**
        VIA
        replaceChildrenOfChildWhenText(ret, getChildPosByTag(ret, 'params'), 'param')*/
    if (node.generator) {
        ret.tag = 'function*';
    }
    if (node.async) {
        ret.tag = 'async-function';
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ExpressionStatement
format.ExpressionStatement = function(parent, node, options) {
    console.log('node : ExpressionStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'stm', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // An expression statement, i.e., a statement consisting of a single expression.
    // process AST-node-property expression and append ittfNode to `ret`
    if (node.expression) {
        if (!node.expression.type) {
            throw 'Node expression has no type: ' + JSON.stringify(node);
        }
        format(ret, node.expression, options);
    }
    else {
        throw new Error('AST-node-property expression undefined: ' + JSON.stringify(node));
    }
    if (replaceWithSingleChild(ret, 'set')) {
    }
    else {
        replaceWithSingleChild(ret, '_');
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node BlockStatement
format.BlockStatement = function(parent, node, options) {
    console.log('node : BlockStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = parent;
    // process AST-node-property-collection body and append ittfNode(s) to `ret`
    if (node.body) {
        if (typeof node.body.length === 'undefined') {
            throw new Error('Property node.body must be an array');
        }
        var i, i_items=node.body, i_len=node.body.length, item;
        for (i=0; i<i_len; i++) {
            item = node.body[i];
            item.__parent = {
                name: 'body', 
                len: node.body.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection body undefined: ' + JSON.stringify(node));
    }
    // process AST-node-property-collection directives and append ittfNode(s) to `ret`
    if (node.directives) {
        if (typeof node.directives.length === 'undefined') {
            throw new Error('Property node.directives must be an array');
        }
        var i, i_items=node.directives, i_len=node.directives.length, item;
        for (i=0; i<i_len; i++) {
            item = node.directives[i];
            item.__parent = {
                name: 'directives', 
                len: node.directives.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection directives undefined: ' + JSON.stringify(node));
    }
    // A block statement, i.e., a sequence of statements surrounded by braces.
    if (ret != null) {
    }
};
// process AST node EmptyStatement
format.EmptyStatement = function(parent, node, options) {
    console.log('node : EmptyStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // An empty statement, i.e., a solitary semicolon.
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node DebuggerStatement
format.DebuggerStatement = function(parent, node, options) {
    console.log('node : DebuggerStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'debugger', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A `debugger` statement.
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node WithStatement
format.WithStatement = function(parent, node, options) {
    console.log('node : WithStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'with', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property object and append ittfNode to `ret`
    if (node.object) {
        if (!node.object.type) {
            throw 'Node object has no type: ' + JSON.stringify(node);
        }
        format(ret, node.object, options);
    }
    else {
        throw new Error('AST-node-property object undefined: ' + JSON.stringify(node));
    }
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    // A `with` statement.
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ReturnStatement
format.ReturnStatement = function(parent, node, options) {
    console.log('node : ReturnStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'return', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property argument and append ittfNode to `ret`
    if (node.argument) {
        if (!node.argument.type) {
            throw 'Node argument has no type: ' + JSON.stringify(node);
        }
        format(ret, node.argument, options);
    }
    console.log('get_text_from_1_children', isChildrenCount(ret, 1));
    var got_text_1 = false;
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified || ret.children[0].isText) {
            var c1 = ret.children[0].textified || ret.children[0].name;
            ret.name = c1;
            ret.textified = ret.name;
            ret.children = [];
            got_text_1 = true;
        }
    }
    console.log('ReturnStatement', ret);
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node LabeledStatement
format.LabeledStatement = function(parent, node, options) {
    console.log('node : LabeledStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'label', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property label and set it in a var
    var p_label = null;
    if (node.label) {
        p_label = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.label.type) {
            throw 'Node label has no type: ' + JSON.stringify(node);
        }
        format(p_label, node.label, options);
        if (p_label.children.length == 1) {
            if (!(p_label.children[0].isText || p_label.children[0].textified)) {
                p_label.tag = p_label.children[0].tag;
                p_label.name = p_label.children[0].name;
                p_label.source = p_label.children[0].source;
                p_label.children = p_label.children[0].children;
            }
            else {
                if (p_label.children[0].textified) {
                    p_label.textified = p_label.children[0].textified;
                }
                if (p_label.children[0].isText) {
                    p_label.isText = true;
                    p_label.name = p_label.children[0].name;
                    p_label.source = p_label.children[0].source;
                    p_label.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property label undefined: ' + JSON.stringify(node));
    }
    ret.name = getNodeText(p_label);
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node BreakStatement
format.BreakStatement = function(parent, node, options) {
    console.log('node : BreakStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'break', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Process AST-node-property label and
    // set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.label) {
        if (!node.label.type) {
            throw 'Node label has no type: ' + JSON.stringify(node);
        }
        var templabel = {
            children: [
                
            ]
        };
        format(templabel, node.label, options);
        /**
            if (templabel .children.length > 0) {
                throw 'node.label must result zero node, returned: ' + templabel.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (templabel.children.length > 0) {
            appto.name = templabel.children[0].name;
        }
        else {
            appto.name = templabel.name;
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ContinueStatement
format.ContinueStatement = function(parent, node, options) {
    console.log('node : ContinueStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'continue', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Process AST-node-property label and
    // set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.label) {
        if (!node.label.type) {
            throw 'Node label has no type: ' + JSON.stringify(node);
        }
        var templabel = {
            children: [
                
            ]
        };
        format(templabel, node.label, options);
        /**
            if (templabel .children.length > 0) {
                throw 'node.label must result zero node, returned: ' + templabel.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (templabel.children.length > 0) {
            appto.name = templabel.children[0].name;
        }
        else {
            appto.name = templabel.name;
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node IfStatement
format.IfStatement = function(parent, node, options) {
    console.log('node : IfStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'if', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_test = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.test) {
        if (!node.test.type) {
            throw 'Node test has no type: ' + JSON.stringify(node);
        }
        format(p_test, node.test, options);
        p_test.tag = 'test';
        ret.children.push(p_test);
        if (p_test.children.length == 1) {
            console.log('*** f_p_tag test children[0].textified', p_test.children[0].textified);
            console.log('*** f_p_tag test children[0].isText', p_test.children[0].isText);
            console.log('*** f_p_tag test children[0].name', p_test.children[0].name);
            if (p_test.children[0].textified) {
                p_test.textified = p_test.children[0].textified;
            }
            if (p_test.children[0].isText) {
                p_test.isText = true;
                p_test.name = p_test.children[0].name;
                p_test.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property test/test not managed by f_p_tag');
            }
        */
    }
    setNameFromChildByTag(ret, 'test', true);
    if (node.consequent) {
        // process AST-node-property consequent and set it in a var
        var p_consequent = null;
        if (node.consequent) {
            p_consequent = {
                textified: null, 
                isText: false, 
                children: [
                    
                ]
            };
            if (!node.consequent.type) {
                throw 'Node consequent has no type: ' + JSON.stringify(node);
            }
            format(p_consequent, node.consequent, options);
            if (p_consequent.children.length == 1) {
                if (!(p_consequent.children[0].isText || p_consequent.children[0].textified)) {
                    p_consequent.tag = p_consequent.children[0].tag;
                    p_consequent.name = p_consequent.children[0].name;
                    p_consequent.source = p_consequent.children[0].source;
                    p_consequent.children = p_consequent.children[0].children;
                }
                else {
                    if (p_consequent.children[0].textified) {
                        p_consequent.textified = p_consequent.children[0].textified;
                    }
                    if (p_consequent.children[0].isText) {
                        p_consequent.isText = true;
                        p_consequent.name = p_consequent.children[0].name;
                        p_consequent.source = p_consequent.children[0].source;
                        p_consequent.children = [];
                    }
                }
            }
        }
        else {
            throw new Error('AST-node-property consequent undefined: ' + JSON.stringify(node));
        }
        console.log('IfStatement', p_consequent);
        if (p_consequent.tag && p_consequent.tag.length > 0) {
            ret.children.push(p_consequent);
        }
        else {
            var i, i_items=p_consequent.children, i_len=p_consequent.children.length, item;
            for (i=0; i<i_len; i++) {
                item = p_consequent.children[i];
                ret.children.push(item);
            }
        }
    }
    if (node.alternate) {
        // process AST-node-property alternate and set it in a var
        var p_alternate = null;
        if (node.alternate) {
            p_alternate = {
                textified: null, 
                isText: false, 
                children: [
                    
                ]
            };
            if (!node.alternate.type) {
                throw 'Node alternate has no type: ' + JSON.stringify(node);
            }
            format(p_alternate, node.alternate, options);
            if (p_alternate.children.length == 1) {
                if (!(p_alternate.children[0].isText || p_alternate.children[0].textified)) {
                    p_alternate.tag = p_alternate.children[0].tag;
                    p_alternate.name = p_alternate.children[0].name;
                    p_alternate.source = p_alternate.children[0].source;
                    p_alternate.children = p_alternate.children[0].children;
                }
                else {
                    if (p_alternate.children[0].textified) {
                        p_alternate.textified = p_alternate.children[0].textified;
                    }
                    if (p_alternate.children[0].isText) {
                        p_alternate.isText = true;
                        p_alternate.name = p_alternate.children[0].name;
                        p_alternate.source = p_alternate.children[0].source;
                        p_alternate.children = [];
                    }
                }
            }
        }
        else {
            throw new Error('AST-node-property alternate undefined: ' + JSON.stringify(node));
        }
        var p_else = {
            tag: 'else', 
            children: [
                
            ]
        };
        console.log('IfStatement', p_consequent);
        if (p_alternate.tag && p_alternate.tag.length > 0) {
            p_else.children.push(p_alternate);
        }
        else {
            var i, i_items=p_alternate.children, i_len=p_alternate.children.length, item;
            for (i=0; i<i_len; i++) {
                item = p_alternate.children[i];
                p_else.children.push(item);
            }
        }
        ret = [ret, p_else];
    }
    else {
        ret = [ret];
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        var i, i_items=ret, i_len=ret.length, item;
        for (i=0; i<i_len; i++) {
            item = ret[i];
            parent.children.push(item);
        }
    }
};
// process AST node SwitchStatement
format.SwitchStatement = function(parent, node, options) {
    console.log('node : SwitchStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'switch', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property discriminant and set it in a var
    var p_discriminant = null;
    if (node.discriminant) {
        p_discriminant = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.discriminant.type) {
            throw 'Node discriminant has no type: ' + JSON.stringify(node);
        }
        format(p_discriminant, node.discriminant, options);
        if (p_discriminant.children.length == 1) {
            if (!(p_discriminant.children[0].isText || p_discriminant.children[0].textified)) {
                p_discriminant.tag = p_discriminant.children[0].tag;
                p_discriminant.name = p_discriminant.children[0].name;
                p_discriminant.source = p_discriminant.children[0].source;
                p_discriminant.children = p_discriminant.children[0].children;
            }
            else {
                if (p_discriminant.children[0].textified) {
                    p_discriminant.textified = p_discriminant.children[0].textified;
                }
                if (p_discriminant.children[0].isText) {
                    p_discriminant.isText = true;
                    p_discriminant.name = p_discriminant.children[0].name;
                    p_discriminant.source = p_discriminant.children[0].source;
                    p_discriminant.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property discriminant undefined: ' + JSON.stringify(node));
    }
    // process AST-node-property-collection cases and append ittfNode(s) to `ret`
    if (node.cases) {
        if (typeof node.cases.length === 'undefined') {
            throw new Error('Property node.cases must be an array');
        }
        var i, i_items=node.cases, i_len=node.cases.length, item;
        for (i=0; i<i_len; i++) {
            item = node.cases[i];
            item.__parent = {
                name: 'cases', 
                len: node.cases.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection cases undefined: ' + JSON.stringify(node));
    }
    // A `switch` statement.
    if (p_discriminant.textified || p_discriminant.isText) {
        ret.name = p_discriminant.textified || p_discriminant.name;
        ret.textified = ret.name;
    }
    else {
        throw new Error('SwitchStatement.discriminant must be textual:' + JSON.stringify(node));
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node SwitchCase
format.SwitchCase = function(parent, node, options) {
    console.log('node : SwitchCase ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'case', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property test and set it in a var
    var p_test = null;
    if (node.test) {
        p_test = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.test.type) {
            throw 'Node test has no type: ' + JSON.stringify(node);
        }
        format(p_test, node.test, options);
        if (p_test.children.length == 1) {
            if (!(p_test.children[0].isText || p_test.children[0].textified)) {
                p_test.tag = p_test.children[0].tag;
                p_test.name = p_test.children[0].name;
                p_test.source = p_test.children[0].source;
                p_test.children = p_test.children[0].children;
            }
            else {
                if (p_test.children[0].textified) {
                    p_test.textified = p_test.children[0].textified;
                }
                if (p_test.children[0].isText) {
                    p_test.isText = true;
                    p_test.name = p_test.children[0].name;
                    p_test.source = p_test.children[0].source;
                    p_test.children = [];
                }
            }
        }
    }
    // process AST-node-property-collection consequent and append ittfNode(s) to `ret`
    if (node.consequent) {
        if (typeof node.consequent.length === 'undefined') {
            throw new Error('Property node.consequent must be an array');
        }
        var i, i_items=node.consequent, i_len=node.consequent.length, item;
        for (i=0; i<i_len; i++) {
            item = node.consequent[i];
            item.__parent = {
                name: 'consequent', 
                len: node.consequent.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection consequent undefined: ' + JSON.stringify(node));
    }
    // A `case` (if `test` is an `Expression`) or `default` (if `test === null`) clause in the body of a `switch` statement.
    //
    if (node.test == null) {
        ret.tag = 'default';
    }
    else {
        if (p_test.textified || p_test.isText) {
            ret.name = p_test.textified || p_test.name;
            ret.textified = ret.name;
        }
        else {
            throw new Error('SwitchCase.test must be textual:' + JSON.stringify(node));
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ThrowStatement
format.ThrowStatement = function(parent, node, options) {
    console.log('node : ThrowStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'throw', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property argument and append ittfNode to `ret`
    if (node.argument) {
        if (!node.argument.type) {
            throw 'Node argument has no type: ' + JSON.stringify(node);
        }
        format(ret, node.argument, options);
    }
    else {
        throw new Error('AST-node-property argument undefined: ' + JSON.stringify(node));
    }
    // A `throw` statement.
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node TryStatement
format.TryStatement = function(parent, node, options) {
    console.log('node : TryStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'try', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property block and append ittfNode to `ret`
    if (node.block) {
        if (!node.block.type) {
            throw 'Node block has no type: ' + JSON.stringify(node);
        }
        format(ret, node.block, options);
    }
    else {
        throw new Error('AST-node-property block undefined: ' + JSON.stringify(node));
    }
    // process AST-node-property handler and append ittfNode to `ret`
    if (node.handler) {
        if (!node.handler.type) {
            throw 'Node handler has no type: ' + JSON.stringify(node);
        }
        format(ret, node.handler, options);
    }
    // process AST-node-property finalizer and append ittfNode to `ret`
    if (node.finalizer) {
        if (!node.finalizer.type) {
            throw 'Node finalizer has no type: ' + JSON.stringify(node);
        }
        format(ret, node.finalizer, options);
    }
    // A `try` statement. If `handler` is `null` then `finalizer` must be a `BlockStatement`.
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node CatchClause
format.CatchClause = function(parent, node, options) {
    console.log('node : CatchClause ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'catch', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A `catch` clause following a `try` block.
    var p_param = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.param) {
        if (!node.param.type) {
            throw 'Node param has no type: ' + JSON.stringify(node);
        }
        format(p_param, node.param, options);
        p_param.tag = 'Pattern | null';
        ret.children.push(p_param);
        if (p_param.children.length == 1) {
            console.log('*** f_p_tag param children[0].textified', p_param.children[0].textified);
            console.log('*** f_p_tag param children[0].isText', p_param.children[0].isText);
            console.log('*** f_p_tag param children[0].name', p_param.children[0].name);
            if (p_param.children[0].textified) {
                p_param.textified = p_param.children[0].textified;
            }
            if (p_param.children[0].isText) {
                p_param.isText = true;
                p_param.name = p_param.children[0].name;
                p_param.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property param/Pattern | null not managed by f_p_tag');
            }
        */
    }
    console.log('get_text_from_1_children', isChildrenCount(ret, 1));
    var got_text_1 = false;
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified || ret.children[0].isText) {
            var c1 = ret.children[0].textified || ret.children[0].name;
            ret.name = c1;
            ret.textified = ret.name;
            ret.children = [];
            got_text_1 = true;
        }
    }
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node WhileStatement
format.WhileStatement = function(parent, node, options) {
    console.log('node : WhileStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'while', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_test = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.test) {
        if (!node.test.type) {
            throw 'Node test has no type: ' + JSON.stringify(node);
        }
        format(p_test, node.test, options);
        p_test.tag = 'test';
        ret.children.push(p_test);
        if (p_test.children.length == 1) {
            console.log('*** f_p_tag test children[0].textified', p_test.children[0].textified);
            console.log('*** f_p_tag test children[0].isText', p_test.children[0].isText);
            console.log('*** f_p_tag test children[0].name', p_test.children[0].name);
            if (p_test.children[0].textified) {
                p_test.textified = p_test.children[0].textified;
            }
            if (p_test.children[0].isText) {
                p_test.isText = true;
                p_test.name = p_test.children[0].name;
                p_test.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property test/test not managed by f_p_tag');
            }
        */
    }
    console.log('get_text_from_1_children', isChildrenCount(ret, 1));
    var got_text_1 = false;
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified || ret.children[0].isText) {
            var c1 = ret.children[0].textified || ret.children[0].name;
            ret.name = c1;
            ret.textified = ret.name;
            ret.children = [];
            got_text_1 = true;
        }
    }
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node DoWhileStatement
format.DoWhileStatement = function(parent, node, options) {
    console.log('node : DoWhileStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'do', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_test = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.test) {
        if (!node.test.type) {
            throw 'Node test has no type: ' + JSON.stringify(node);
        }
        format(p_test, node.test, options);
        p_test.tag = 'test';
        ret.children.push(p_test);
        if (p_test.children.length == 1) {
            console.log('*** f_p_tag test children[0].textified', p_test.children[0].textified);
            console.log('*** f_p_tag test children[0].isText', p_test.children[0].isText);
            console.log('*** f_p_tag test children[0].name', p_test.children[0].name);
            if (p_test.children[0].textified) {
                p_test.textified = p_test.children[0].textified;
            }
            if (p_test.children[0].isText) {
                p_test.isText = true;
                p_test.name = p_test.children[0].name;
                p_test.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property test/test not managed by f_p_tag');
            }
        */
    }
    console.log('get_text_from_1_children', isChildrenCount(ret, 1));
    var got_text_1 = false;
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified || ret.children[0].isText) {
            var c1 = ret.children[0].textified || ret.children[0].name;
            ret.name = c1;
            ret.textified = ret.name;
            ret.children = [];
            got_text_1 = true;
        }
    }
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ForStatement
format.ForStatement = function(parent, node, options) {
    console.log('node : ForStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'for', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_init = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.init) {
        if (!node.init.type) {
            throw 'Node init has no type: ' + JSON.stringify(node);
        }
        format(p_init, node.init, options);
        p_init.tag = 'init';
        ret.children.push(p_init);
        if (p_init.children.length == 1) {
            console.log('*** f_p_tag init children[0].textified', p_init.children[0].textified);
            console.log('*** f_p_tag init children[0].isText', p_init.children[0].isText);
            console.log('*** f_p_tag init children[0].name', p_init.children[0].name);
            if (p_init.children[0].textified) {
                p_init.textified = p_init.children[0].textified;
            }
            if (p_init.children[0].isText) {
                p_init.isText = true;
                p_init.name = p_init.children[0].name;
                p_init.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property init/init not managed by f_p_tag');
            }
        */
    }
    var p_test = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.test) {
        if (!node.test.type) {
            throw 'Node test has no type: ' + JSON.stringify(node);
        }
        format(p_test, node.test, options);
        p_test.tag = 'test';
        ret.children.push(p_test);
        if (p_test.children.length == 1) {
            console.log('*** f_p_tag test children[0].textified', p_test.children[0].textified);
            console.log('*** f_p_tag test children[0].isText', p_test.children[0].isText);
            console.log('*** f_p_tag test children[0].name', p_test.children[0].name);
            if (p_test.children[0].textified) {
                p_test.textified = p_test.children[0].textified;
            }
            if (p_test.children[0].isText) {
                p_test.isText = true;
                p_test.name = p_test.children[0].name;
                p_test.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property test/test not managed by f_p_tag');
            }
        */
    }
    var p_update = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.update) {
        if (!node.update.type) {
            throw 'Node update has no type: ' + JSON.stringify(node);
        }
        format(p_update, node.update, options);
        p_update.tag = 'update';
        ret.children.push(p_update);
        if (p_update.children.length == 1) {
            console.log('*** f_p_tag update children[0].textified', p_update.children[0].textified);
            console.log('*** f_p_tag update children[0].isText', p_update.children[0].isText);
            console.log('*** f_p_tag update children[0].name', p_update.children[0].name);
            if (p_update.children[0].textified) {
                p_update.textified = p_update.children[0].textified;
            }
            if (p_update.children[0].isText) {
                p_update.isText = true;
                p_update.name = p_update.children[0].name;
                p_update.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property update/update not managed by f_p_tag');
            }
        */
    }
    console.log('p_init.textified', p_init.textified);
    var c1 = p_init.isText ? p_init.name : (p_init.textified ? p_init.textified : '');
    var c2 = p_test.isText ? p_test.name : (p_test.textified ? p_test.textified : '');
    var c3 = p_update.isText ? p_update.name : (p_update.textified ? p_update.textified : '');
    ret.name = c1 + '; ' + c2 + '; ' + c3;
    removeChildByTag(ret, 'init');
    removeChildByTag(ret, 'test');
    removeChildByTag(ret, 'update');
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ForInStatement
format.ForInStatement = function(parent, node, options) {
    console.log('node : ForInStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'for', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_left = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.left) {
        if (!node.left.type) {
            throw 'Node left has no type: ' + JSON.stringify(node);
        }
        format(p_left, node.left, options);
        p_left.tag = 'left';
        ret.children.push(p_left);
        if (p_left.children.length == 1) {
            console.log('*** f_p_tag left children[0].textified', p_left.children[0].textified);
            console.log('*** f_p_tag left children[0].isText', p_left.children[0].isText);
            console.log('*** f_p_tag left children[0].name', p_left.children[0].name);
            if (p_left.children[0].textified) {
                p_left.textified = p_left.children[0].textified;
            }
            if (p_left.children[0].isText) {
                p_left.isText = true;
                p_left.name = p_left.children[0].name;
                p_left.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property left/left not managed by f_p_tag');
            }
        */
    }
    var p_right = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.right) {
        if (!node.right.type) {
            throw 'Node right has no type: ' + JSON.stringify(node);
        }
        format(p_right, node.right, options);
        p_right.tag = 'right';
        ret.children.push(p_right);
        if (p_right.children.length == 1) {
            console.log('*** f_p_tag right children[0].textified', p_right.children[0].textified);
            console.log('*** f_p_tag right children[0].isText', p_right.children[0].isText);
            console.log('*** f_p_tag right children[0].name', p_right.children[0].name);
            if (p_right.children[0].textified) {
                p_right.textified = p_right.children[0].textified;
            }
            if (p_right.children[0].isText) {
                p_right.isText = true;
                p_right.name = p_right.children[0].name;
                p_right.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property right/right not managed by f_p_tag');
            }
        */
    }
    var got_text_2 = false;
    if (isChildrenCount(ret, 2)) {
        if ((ret.children[0].textified || ret.children[0].isText) && (ret.children[1].textified || ret.children[1].isText)) {
            var c1 = ret.children[0].textified || ret.children[0].name;
            var c2 = ret.children[1].textified || ret.children[1].name;
            ret.name = c1 + ' in ' + c2;
            ret.textified = ret.name;
            ret.children = [];
            got_text_2 = true;
            got_text_2 = true;
        }
    }
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ForOfStatement
format.ForOfStatement = function(parent, node, options) {
    options.mustBeText = true;
    console.log('node : ForOfStatement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'for', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_left = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.left) {
        if (!node.left.type) {
            throw 'Node left has no type: ' + JSON.stringify(node);
        }
        format(p_left, node.left, options);
        p_left.tag = 'left';
        ret.children.push(p_left);
        if (p_left.children.length == 1) {
            console.log('*** f_p_tag left children[0].textified', p_left.children[0].textified);
            console.log('*** f_p_tag left children[0].isText', p_left.children[0].isText);
            console.log('*** f_p_tag left children[0].name', p_left.children[0].name);
            if (p_left.children[0].textified) {
                p_left.textified = p_left.children[0].textified;
            }
            if (p_left.children[0].isText) {
                p_left.isText = true;
                p_left.name = p_left.children[0].name;
                p_left.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property left/left not managed by f_p_tag');
            }
        */
    }
    var p_right = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.right) {
        if (!node.right.type) {
            throw 'Node right has no type: ' + JSON.stringify(node);
        }
        format(p_right, node.right, options);
        p_right.tag = 'right';
        ret.children.push(p_right);
        if (p_right.children.length == 1) {
            console.log('*** f_p_tag right children[0].textified', p_right.children[0].textified);
            console.log('*** f_p_tag right children[0].isText', p_right.children[0].isText);
            console.log('*** f_p_tag right children[0].name', p_right.children[0].name);
            if (p_right.children[0].textified) {
                p_right.textified = p_right.children[0].textified;
            }
            if (p_right.children[0].isText) {
                p_right.isText = true;
                p_right.name = p_right.children[0].name;
                p_right.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property right/right not managed by f_p_tag');
            }
        */
    }
    var got_text_2 = false;
    if (isChildrenCount(ret, 2)) {
        if ((ret.children[0].textified || ret.children[0].isText) && (ret.children[1].textified || ret.children[1].isText)) {
            var c1 = ret.children[0].textified || ret.children[0].name;
            var c2 = ret.children[1].textified || ret.children[1].name;
            ret.name = c1 + ' of ' + c2;
            ret.textified = ret.name;
            ret.children = [];
            got_text_2 = true;
            got_text_2 = true;
        }
    }
    if (!got_text_2) {
    }
    ret.children = [];
    console.log('node.await', node.await);
    if (!!node.await == true) {
        ret.children.push({
            tag: 'await', 
            children: [
                
            ]
        });
    }
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
        options.mustBeText = false;
    }
};
// process AST node FunctionDeclaration
format.FunctionDeclaration = function(parent, node, options) {
    console.log('node : FunctionDeclaration ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'function', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A function [declaration](#functiondeclaration) or [expression](#functionexpression).
    // Process AST-node-property id and
    // set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.id) {
        if (!node.id.type) {
            throw 'Node id has no type: ' + JSON.stringify(node);
        }
        var tempid = {
            children: [
                
            ]
        };
        format(tempid, node.id, options);
        /**
            if (tempid .children.length > 0) {
                throw 'node.id must result zero node, returned: ' + tempid.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempid.children.length > 0) {
            appto.name = tempid.children[0].name;
        }
        else {
            appto.name = tempid.name;
        }
    }
    // process AST-node-property-collection params and
    // embed its array of nodes in a new tag
    if (node.params) {
        if (typeof node.params.length === 'undefined') {
            throw new Error('Property node.params must be an array');
        }
        if (node.params.length > 0) {
            var tempparams = {
                tag: 'params', 
                children: [
                    
                ]
            };
            var i, i_items=node.params, i_len=node.params.length, item;
            for (i=0; i<i_len; i++) {
                item = node.params[i];
                item.__parent = {
                    name: 'params', 
                    len: node.params.length
                };
                format(tempparams, item, options);
            }
            ret.children.push(tempparams);
        }
    }
    processParams(ret);
    /**
        VIA
        replaceChildrenOfChildWhenText(ret, getChildPosByTag(ret, 'params'), 'param')*/
    // b( generator
    // b( async
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    if (node.generator) {
        ret.tag = 'function*';
    }
    if (node.async) {
        ret.tag = 'async-function';
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node VariableDeclaration
format.VariableDeclaration = function(parent, node, options) {
    console.log('node : VariableDeclaration ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: node.kind, 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // enum "var" | "let" | "const"
    // process AST-node-property-collection declarations and append ittfNode(s) to `ret`
    if (node.declarations) {
        if (typeof node.declarations.length === 'undefined') {
            throw new Error('Property node.declarations must be an array');
        }
        var i, i_items=node.declarations, i_len=node.declarations.length, item;
        for (i=0; i<i_len; i++) {
            item = node.declarations[i];
            item.__parent = {
                name: 'declarations', 
                len: node.declarations.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection declarations undefined: ' + JSON.stringify(node));
    }
    // log '=== VariableDeclaration ittf result 1', ret
    console.log('get_text_from_1_children', isChildrenCount(ret, 1));
    var got_text_1 = false;
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified || ret.children[0].isText) {
            var c1 = ret.children[0].textified || ret.children[0].name;
            ret.name = c1;
            ret.textified = ret.name;
            ret.children = [];
            got_text_1 = true;
        }
    }
    // log '=== VariableDeclaration ittf result 2', ret, 'got_text_1', got_text_1
    if (got_text_1) {
        ret.textified = node.kind + ' ' + ret.textified;
    }
    else if (ret.children.length == 1) {
        if (ret.children[0].children.length == 1) {
            ret.name = ret.children[0].name;
            ret.children[0] = ret.children[0].children[0];
            ret.textified = node.kind + ' ' + ret.name;
        }
    }
    else if (ret.children.length > 1) {
        var sb = [];
        var i, i_items=ret.children, i_len=ret.children.length, item;
        for (i=0; i<i_len; i++) {
            item = ret.children[i];
            if (item.textified) {
                sb.push(item.textified);
            }
            else {
                sb = null;
                break;
            }
        }
        if (sb) {
            ret.textified = node.kind + ' ' + sb.join(', ');
        }
    }
    // log 'VariableDeclaration.exit.ret', ret
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node VariableDeclarator
format.VariableDeclarator = function(parent, node, options) {
    console.log('node : VariableDeclarator ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'decl', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    const save = options.mustBeText;
    options.mustBeText = true;
    // process AST-node-property id and set it in a var
    var p_id = null;
    if (node.id) {
        p_id = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.id.type) {
            throw 'Node id has no type: ' + JSON.stringify(node);
        }
        format(p_id, node.id, options);
        if (p_id.children.length == 1) {
            if (!(p_id.children[0].isText || p_id.children[0].textified)) {
                p_id.tag = p_id.children[0].tag;
                p_id.name = p_id.children[0].name;
                p_id.source = p_id.children[0].source;
                p_id.children = p_id.children[0].children;
            }
            else {
                if (p_id.children[0].textified) {
                    p_id.textified = p_id.children[0].textified;
                }
                if (p_id.children[0].isText) {
                    p_id.isText = true;
                    p_id.name = p_id.children[0].name;
                    p_id.source = p_id.children[0].source;
                    p_id.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property id undefined: ' + JSON.stringify(node));
    }
    ret.name = getNodeText(p_id);
    options.mustBeText = save;
    // process AST-node-property init and set it in a var
    var p_init = null;
    if (node.init) {
        p_init = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.init.type) {
            throw 'Node init has no type: ' + JSON.stringify(node);
        }
        format(p_init, node.init, options);
        if (p_init.children.length == 1) {
            if (!(p_init.children[0].isText || p_init.children[0].textified)) {
                p_init.tag = p_init.children[0].tag;
                p_init.name = p_init.children[0].name;
                p_init.source = p_init.children[0].source;
                p_init.children = p_init.children[0].children;
            }
            else {
                if (p_init.children[0].textified) {
                    p_init.textified = p_init.children[0].textified;
                }
                if (p_init.children[0].isText) {
                    p_init.isText = true;
                    p_init.name = p_init.children[0].name;
                    p_init.source = p_init.children[0].source;
                    p_init.children = [];
                }
            }
        }
    }
    if (p_init == null) {
        ret.textified = ret.name;
    }
    else {
        // log 'VariableDeclarator p_id', p_id, 'p_init', p_init
        if (p_init != null) {
            if (isTextualNode(p_init)) {
                ret.name += ' = ' + getNodeText(p_init);
                ret.textified = ret.name;
            }
            else {
                ret.children.push(p_init);
            }
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node Decorator
format.Decorator = function(parent, node, options) {
    console.log('node : Decorator ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '@decorator', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property expression and set it in a var
    var p_expression = null;
    if (node.expression) {
        p_expression = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.expression.type) {
            throw 'Node expression has no type: ' + JSON.stringify(node);
        }
        format(p_expression, node.expression, options);
        if (p_expression.children.length == 1) {
            if (!(p_expression.children[0].isText || p_expression.children[0].textified)) {
                p_expression.tag = p_expression.children[0].tag;
                p_expression.name = p_expression.children[0].name;
                p_expression.source = p_expression.children[0].source;
                p_expression.children = p_expression.children[0].children;
            }
            else {
                if (p_expression.children[0].textified) {
                    p_expression.textified = p_expression.children[0].textified;
                }
                if (p_expression.children[0].isText) {
                    p_expression.isText = true;
                    p_expression.name = p_expression.children[0].name;
                    p_expression.source = p_expression.children[0].source;
                    p_expression.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property expression undefined: ' + JSON.stringify(node));
    }
    if (isTextualNode(p_expression)) {
        ret.name = getNodeText(p_expression);
    }
    else {
        ret.children.push(p_expression);
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node Directive
format.Directive = function(parent, node, options) {
    console.log('node : Directive ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'directive', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    if (node.value && node.value.value === 'use strict') {
        ret = null;
    }
    else {
        // process AST-node-property value and set it in a var
        var p_value = null;
        if (node.value) {
            p_value = {
                textified: null, 
                isText: false, 
                children: [
                    
                ]
            };
            if (!node.value.type) {
                throw 'Node value has no type: ' + JSON.stringify(node);
            }
            format(p_value, node.value, options);
            if (p_value.children.length == 1) {
                if (!(p_value.children[0].isText || p_value.children[0].textified)) {
                    p_value.tag = p_value.children[0].tag;
                    p_value.name = p_value.children[0].name;
                    p_value.source = p_value.children[0].source;
                    p_value.children = p_value.children[0].children;
                }
                else {
                    if (p_value.children[0].textified) {
                        p_value.textified = p_value.children[0].textified;
                    }
                    if (p_value.children[0].isText) {
                        p_value.isText = true;
                        p_value.name = p_value.children[0].name;
                        p_value.source = p_value.children[0].source;
                        p_value.children = [];
                    }
                }
            }
        }
        else {
            throw new Error('AST-node-property value undefined: ' + JSON.stringify(node));
        }
        if (isTextualNode(p_value)) {
            ret.name = getNodeText(p_value);
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node DirectiveLiteral
format.DirectiveLiteral = function(parent, node, options) {
    console.log('node : DirectiveLiteral ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node Expression
format.Expression = function(parent, node, options) {
    console.log('node : Expression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'expr', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Any expression node. Since the left-hand side of an assignment may be any expression in general, an expression can also be a pattern.
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node Super
format.Super = function(parent, node, options) {
    console.log('node : Super ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'super', 
        name: '', 
        isText: true, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A `super` pseudo-expression.
    ret.name = 'super';
    if (ret != null) {
        ret.textified = ret.name;
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node Import
format.Import = function(parent, node, options) {
    console.log('node : Import ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'import', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A `import` pseudo-expression.
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ThisExpression
format.ThisExpression = function(parent, node, options) {
    console.log('node : ThisExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'this', 
        name: '', 
        isText: true, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A `this` expression.
    ret.name = 'this';
    if (ret != null) {
        ret.textified = ret.name;
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ArrowFunctionExpression
format.ArrowFunctionExpression = function(parent, node, options) {
    console.log('node : ArrowFunctionExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '=>', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    if (verify.isArray(node.body) == false) {
        node.body = [node.body];
    }
    // process AST-node-property-collection params and
    // embed its array of nodes in a new tag
    if (node.params) {
        if (typeof node.params.length === 'undefined') {
            throw new Error('Property node.params must be an array');
        }
        if (node.params.length > 0) {
            var tempparams = {
                tag: 'params', 
                children: [
                    
                ]
            };
            var i, i_items=node.params, i_len=node.params.length, item;
            for (i=0; i<i_len; i++) {
                item = node.params[i];
                item.__parent = {
                    name: 'params', 
                    len: node.params.length
                };
                format(tempparams, item, options);
            }
            ret.children.push(tempparams);
        }
    }
    processParams(ret);
    // process AST-node-property-collection body and append ittfNode(s) to `ret`
    if (node.body) {
        if (typeof node.body.length === 'undefined') {
            throw new Error('Property node.body must be an array');
        }
        var i, i_items=node.body, i_len=node.body.length, item;
        for (i=0; i<i_len; i++) {
            item = node.body[i];
            item.__parent = {
                name: 'body', 
                len: node.body.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection body undefined: ' + JSON.stringify(node));
    }
    console.log('node.expression', node.expression);
    if (!!node.expression == true) {
        ret.children.push({
            tag: 'expression', 
            children: [
                
            ]
        });
    }
    console.log('*** ArrowFunctionExpression.ret.params', getChildByTag(ret, 'params'));
    // A fat arrow function expression, e.g., `let foo = (bar) => { /* body */ }`.
    if (node.async) {
        ret.tag = 'async=>';
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node YieldExpression
format.YieldExpression = function(parent, node, options) {
    console.log('node : YieldExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'yield', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_argument = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.argument) {
        if (!node.argument.type) {
            throw 'Node argument has no type: ' + JSON.stringify(node);
        }
        format(p_argument, node.argument, options);
        p_argument.tag = 'argument';
        ret.children.push(p_argument);
        if (p_argument.children.length == 1) {
            console.log('*** f_p_tag argument children[0].textified', p_argument.children[0].textified);
            console.log('*** f_p_tag argument children[0].isText', p_argument.children[0].isText);
            console.log('*** f_p_tag argument children[0].name', p_argument.children[0].name);
            if (p_argument.children[0].textified) {
                p_argument.textified = p_argument.children[0].textified;
            }
            if (p_argument.children[0].isText) {
                p_argument.isText = true;
                p_argument.name = p_argument.children[0].name;
                p_argument.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property argument/argument not managed by f_p_tag');
            }
        */
    }
    console.log('get_text_from_1_children', isChildrenCount(ret, 1));
    var got_text_1 = false;
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified || ret.children[0].isText) {
            var c1 = ret.children[0].textified || ret.children[0].name;
            ret.name = c1;
            ret.textified = ret.name;
            ret.children = [];
            got_text_1 = true;
        }
    }
    console.log('node.delegate', node.delegate);
    if (!!node.delegate == true) {
        ret.children.push({
            tag: 'delegate', 
            children: [
                
            ]
        });
    }
    // A `yield` expression.
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node AwaitExpression
format.AwaitExpression = function(parent, node, options) {
    console.log('node : AwaitExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'await', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property argument and append ittfNode to `ret`
    if (node.argument) {
        if (!node.argument.type) {
            throw 'Node argument has no type: ' + JSON.stringify(node);
        }
        format(ret, node.argument, options);
    }
    // A `await` expression.
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ArrayExpression
format.ArrayExpression = function(parent, node, options) {
    console.log('node : ArrayExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '[', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property-collection elements and append ittfNode(s) to `ret`
    if (node.elements) {
        if (typeof node.elements.length === 'undefined') {
            throw new Error('Property node.elements must be an array');
        }
        var i, i_items=node.elements, i_len=node.elements.length, item;
        for (i=0; i<i_len; i++) {
            item = node.elements[i];
            item.__parent = {
                name: 'elements', 
                len: node.elements.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection elements undefined: ' + JSON.stringify(node));
    }
    // An array expression.
    if (options.mustBeText) {
        if (setTextList(ret, ', ')) {
            ret.textified = '[' + ret.textified + ']';
            console.log('### ArrayExpression', 'name:', ret.name, 'textified', ret.textified, ret.isText);
        }
        else {
            throw new Error("ArrayExpression. Cannot textify node as requested: " + JSON.stringify(node));
        }
    }
    else if (options.couldBeText) {
        var tlist = getTextList(ret, ', ');
        if (tlist && tlist.length < 15) {
            ret.textified = '[' + ret.textified + ']';
            // TODO??? set ret.children = []
        }
        else {
            ret.textified = null;
            var i, i_items=ret.children, i_len=ret.children.length, item;
            for (i=0; i<i_len; i++) {
                item = ret.children[i];
                if (isTextualNode(item)) {
                    item.tag = '@';
                    item.name = getNodeText(item);
                }
                else if (['member-expr', 'ident', 'literal'].indexOf(item.tag) > -1) {
                    item.tag = '@';
                }
            }
        }
    }
    else {
        var i, i_items=ret.children, i_len=ret.children.length, item;
        for (i=0; i<i_len; i++) {
            item = ret.children[i];
            if (isTextualNode(item)) {
                item.tag = '@';
                item.name = getNodeText(item);
            }
            else if (['member-expr', 'ident', 'literal'].indexOf(item.tag) > -1) {
                item.tag = '@';
            }
        }
    }
    if (ret.children.length == 0) {
        ret.name = ret.textified = '[]';
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ObjectExpression
format.ObjectExpression = function(parent, node, options) {
    console.log('node : ObjectExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '{', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property-collection properties and append ittfNode(s) to `ret`
    if (node.properties) {
        if (typeof node.properties.length === 'undefined') {
            throw new Error('Property node.properties must be an array');
        }
        var i, i_items=node.properties, i_len=node.properties.length, item;
        for (i=0; i<i_len; i++) {
            item = node.properties[i];
            item.__parent = {
                name: 'properties', 
                len: node.properties.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection properties undefined: ' + JSON.stringify(node));
    }
    if (options.mustBeText) {
        if (setTextList(ret, ', ')) {
            ret.textified = '{' + ret.textified + '}';
            if (node.extra && node.extra.parenthesized == true) {
                ret.textified = '(' + ret.textified + ')';
            }
        }
        else {
            throw new Error("ObjectExpression. Cannot textify node as requested: " + JSON.stringify(node));
        }
    }
    else {
        var i, i_items=ret.children, i_len=ret.children.length, item;
        for (i=0; i<i_len; i++) {
            item = ret.children[i];
            if (item.tag === '...') {
                item.name = item.textified;
                item.tag = '@';
            }
        }
        if (!ret.textified && ret.children.length == 0) {
            if (node.extra && node.extra.parenthesized == true) {
                ret.name = ret.textified = '({})';
            }
            else {
                ret.name = ret.textified = '{}';
            }
        }
        else {
            if (node.extra && node.extra.parenthesized == true) {
                var temp = {
                    tag: '(', 
                    children: [
                        ret
                    ]
                };
                ret = temp;
            }
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ObjectProperty
format.ObjectProperty = function(parent, node, options) {
    console.log('node : ObjectProperty ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '@', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    const save = options.mustBeText;
    options.mustBeText = true;
    // process AST-node-property key and set it in a var
    var p_key = null;
    if (node.key) {
        p_key = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.key.type) {
            throw 'Node key has no type: ' + JSON.stringify(node);
        }
        format(p_key, node.key, options);
        if (p_key.children.length == 1) {
            if (!(p_key.children[0].isText || p_key.children[0].textified)) {
                p_key.tag = p_key.children[0].tag;
                p_key.name = p_key.children[0].name;
                p_key.source = p_key.children[0].source;
                p_key.children = p_key.children[0].children;
            }
            else {
                if (p_key.children[0].textified) {
                    p_key.textified = p_key.children[0].textified;
                }
                if (p_key.children[0].isText) {
                    p_key.isText = true;
                    p_key.name = p_key.children[0].name;
                    p_key.source = p_key.children[0].source;
                    p_key.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property key undefined: ' + JSON.stringify(node));
    }
    ret.name = getNodeText(p_key);
    options.mustBeText = save;
    if (node.computed) {
        ret.name = '[' + ret.name + ']';
    }
    // process AST-node-property-collection decorators and append ittfNode(s) to `ret`
    if (node.decorators) {
        if (typeof node.decorators.length === 'undefined') {
            throw new Error('Property node.decorators must be an array');
        }
        var i, i_items=node.decorators, i_len=node.decorators.length, item;
        for (i=0; i<i_len; i++) {
            item = node.decorators[i];
            item.__parent = {
                name: 'decorators', 
                len: node.decorators.length
            };
            format(ret, item, options);
        }
    }
    // process AST-node-property value and set it in a var
    var p_value = null;
    if (node.value) {
        p_value = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.value.type) {
            throw 'Node value has no type: ' + JSON.stringify(node);
        }
        format(p_value, node.value, options);
        if (p_value.children.length == 1) {
            if (!(p_value.children[0].isText || p_value.children[0].textified)) {
                p_value.tag = p_value.children[0].tag;
                p_value.name = p_value.children[0].name;
                p_value.source = p_value.children[0].source;
                p_value.children = p_value.children[0].children;
            }
            else {
                if (p_value.children[0].textified) {
                    p_value.textified = p_value.children[0].textified;
                }
                if (p_value.children[0].isText) {
                    p_value.isText = true;
                    p_value.name = p_value.children[0].name;
                    p_value.source = p_value.children[0].source;
                    p_value.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property value undefined: ' + JSON.stringify(node));
    }
    if (isTextualNode(p_value)) {
        if (options.mustBeText) {
            ret.textified = ret.name += ': ' + getNodeText(p_value);
        }
        else {
            ret.name += ' ' + getNodeText(p_value);
        }
    }
    else {
        ret.children.push(p_value);
    }
    // TODO b( computed
    // TODO b( shorthand
    if (ret.children.length == 1 && ret.children[0].tag === '{') {
        ret.tag = '{' + ret.tag.substr(1);
        ret.children = ret.children[0].children;
    }
    else if (ret.children.length == 1 && ret.children[0].tag === '[') {
        ret.tag = '[' + ret.tag.substr(1);
        ret.children = ret.children[0].children;
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ObjectMethod
format.ObjectMethod = function(parent, node, options) {
    console.log('node : ObjectMethod ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: node.kind, 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // s( kind
    // enum "get" | "set" | "method"
    const save = options.mustBeText;
    options.mustBeText = true;
    // process AST-node-property key and set it in a var
    var p_key = null;
    if (node.key) {
        p_key = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.key.type) {
            throw 'Node key has no type: ' + JSON.stringify(node);
        }
        format(p_key, node.key, options);
        if (p_key.children.length == 1) {
            if (!(p_key.children[0].isText || p_key.children[0].textified)) {
                p_key.tag = p_key.children[0].tag;
                p_key.name = p_key.children[0].name;
                p_key.source = p_key.children[0].source;
                p_key.children = p_key.children[0].children;
            }
            else {
                if (p_key.children[0].textified) {
                    p_key.textified = p_key.children[0].textified;
                }
                if (p_key.children[0].isText) {
                    p_key.isText = true;
                    p_key.name = p_key.children[0].name;
                    p_key.source = p_key.children[0].source;
                    p_key.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property key undefined: ' + JSON.stringify(node));
    }
    ret.name = getNodeText(p_key);
    options.mustBeText = save;
    // process AST-node-property-collection params and
    // embed its array of nodes in a new tag
    if (node.params) {
        if (typeof node.params.length === 'undefined') {
            throw new Error('Property node.params must be an array');
        }
        if (node.params.length > 0) {
            var tempparams = {
                tag: 'params', 
                children: [
                    
                ]
            };
            var i, i_items=node.params, i_len=node.params.length, item;
            for (i=0; i<i_len; i++) {
                item = node.params[i];
                item.__parent = {
                    name: 'params', 
                    len: node.params.length
                };
                format(tempparams, item, options);
            }
            ret.children.push(tempparams);
        }
    }
    processParams(ret);
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    ret.tag = ret.tag == 'constructor' ? 'ctor' : (ret.tag == 'method' ? 'm' : ret.tag);
    if (node.async) {
        ret.tag = 'async-' + ret.tag;
    }
    setNameFromChildByTag(ret, 'key', true);
    if (ret.tag === 'ctor') {
        ret.name = '';
    }
    else if (node.computed) {
        ret.name = '[' + ret.name + ']';
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node FunctionExpression
format.FunctionExpression = function(parent, node, options) {
    console.log('node : FunctionExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'function', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Process AST-node-property id and
    // set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.id) {
        if (!node.id.type) {
            throw 'Node id has no type: ' + JSON.stringify(node);
        }
        var tempid = {
            children: [
                
            ]
        };
        format(tempid, node.id, options);
        /**
            if (tempid .children.length > 0) {
                throw 'node.id must result zero node, returned: ' + tempid.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempid.children.length > 0) {
            appto.name = tempid.children[0].name;
        }
        else {
            appto.name = tempid.name;
        }
    }
    // process AST-node-property-collection params and
    // embed its array of nodes in a new tag
    if (node.params) {
        if (typeof node.params.length === 'undefined') {
            throw new Error('Property node.params must be an array');
        }
        if (node.params.length > 0) {
            var tempparams = {
                tag: 'params', 
                children: [
                    
                ]
            };
            var i, i_items=node.params, i_len=node.params.length, item;
            for (i=0; i<i_len; i++) {
                item = node.params[i];
                item.__parent = {
                    name: 'params', 
                    len: node.params.length
                };
                format(tempparams, item, options);
            }
            ret.children.push(tempparams);
        }
    }
    // [ Pattern ]
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    // b( generator
    // b( async
    processParams(ret);
    /**
        VIA
        replaceChildrenOfChildWhenText(ret, getChildPosByTag(ret, 'params'), 'param')*/
    if (node.generator) {
        ret.tag = 'function*';
    }
    if (node.async) {
        ret.tag = 'async-function';
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node UnaryExpression
format.UnaryExpression = function(parent, node, options) {
    console.log('node : UnaryExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'op' + node.operator, 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A unary operator expression.
    // s( operator, UnaryOperator enum "-" | "+" | "!" | "~" | "typeof" | "void" | "delete" | "throw"
    // b( prefix
    // process AST-node-property argument and set it in a var
    var p_argument = null;
    if (node.argument) {
        p_argument = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.argument.type) {
            throw 'Node argument has no type: ' + JSON.stringify(node);
        }
        format(p_argument, node.argument, options);
        if (p_argument.children.length == 1) {
            if (!(p_argument.children[0].isText || p_argument.children[0].textified)) {
                p_argument.tag = p_argument.children[0].tag;
                p_argument.name = p_argument.children[0].name;
                p_argument.source = p_argument.children[0].source;
                p_argument.children = p_argument.children[0].children;
            }
            else {
                if (p_argument.children[0].textified) {
                    p_argument.textified = p_argument.children[0].textified;
                }
                if (p_argument.children[0].isText) {
                    p_argument.isText = true;
                    p_argument.name = p_argument.children[0].name;
                    p_argument.source = p_argument.children[0].source;
                    p_argument.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property argument undefined: ' + JSON.stringify(node));
    }
    if (isTextualNode(p_argument)) {
        ret.name = getNodeText(p_argument);
        const space = ['-','+','!','{'].indexOf(node.operator) > -1 ? '' : ' ';
        ret.textified = node.operator + space + ret.name;
    }
    else {
        ret.children.push(p_argument);
    }
    if (node.__parent && node.__parent.name === 'body' && node.__parent.len == 1) {
        if (node.extra && node.extra.parenthesized == true) {
            // is the return value of an ArrowExpression
            // TODO ...
            if (isTextualNode(p_argument)) {
                ret.tag = '(';
                ret.name = node.operator + getNodeText(p_argument);
                ret.textified = '(' + node.operator + getNodeText(p_argument) + ')';
            }
            else {
                var temp = {
                    tag: '(', 
                    children: [
                        ret
                    ]
                };
                ret = temp;
            }
        }
        else {
            // TODO ...
            if (isTextualNode(p_argument)) {
                ret.tag = '+';
                ret.name = node.operator + getNodeText(p_argument);
            }
            else {
                var temp = {
                    tag: '+', 
                    children: [
                        ret
                    ]
                };
                ret = temp;
            }
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node UpdateExpression
format.UpdateExpression = function(parent, node, options) {
    console.log('node : UpdateExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'op' + node.operator, 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // An update (increment or decrement) operator expression.
    // s( operator, UpdateOperator enum "++" | "--"
    // process AST-node-property argument and append ittfNode to `ret`
    if (node.argument) {
        if (!node.argument.type) {
            throw 'Node argument has no type: ' + JSON.stringify(node);
        }
        format(ret, node.argument, options);
    }
    else {
        throw new Error('AST-node-property argument undefined: ' + JSON.stringify(node));
    }
    // b( prefix
    console.log('get_text_from_1_children', isChildrenCount(ret, 1));
    var got_text_1 = false;
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified || ret.children[0].isText) {
            var c1 = ret.children[0].textified || ret.children[0].name;
            ret.name = c1;
            ret.textified = ret.name;
            ret.children = [];
            got_text_1 = true;
        }
    }
    if (got_text_1) {
        ret.tag = 'set';
        if (node.prefix) {
            ret.name = node.operator + ret.name;
        }
        else {
            ret.name = ret.name + node.operator;
        }
        ret.textified = ret.name;
    }
    if (node.prefix) {
        ret.tag = node.operator + 'op';
    }
    if (node.__parent && node.__parent.name === 'body' && node.__parent.len == 1) {
        // is the return value of an ArrowExpression
        if (got_text_1) {
            if (node.extra && node.extra.parenthesized == true) {
                ret.tag = '(';
            }
            else {
                ret.tag = '+';
            }
        }
        else {
            // TODO
            // is the return value of an ArrowExpression
            if (got_text_1) {
                ret.tag = '(';
            }
            else {
                ret.tag = '(' + ret.tag;
            }
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node BinaryExpression
format.BinaryExpression = function(parent, node, options) {
    console.log('node : BinaryExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'op' + node.operator, 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A binary operator token.
    // s( operator, BinaryOperator
    // enum "==" | "!=" | "===" | "!==" "<" | "<=" | ">" | ">=" | "<<" | ">>" | ">>>" | "+" | "-" | "*" | "/" | "%" | "|" | "^" | "&" | "in" | "instanceof" | "|>"
    if (node.operator.length > 1) {
        ret.tag = node.operator;
    }
    // process AST-node-property left and set it in a var
    var p_left = null;
    if (node.left) {
        p_left = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.left.type) {
            throw 'Node left has no type: ' + JSON.stringify(node);
        }
        format(p_left, node.left, options);
        if (p_left.children.length == 1) {
            if (!(p_left.children[0].isText || p_left.children[0].textified)) {
                p_left.tag = p_left.children[0].tag;
                p_left.name = p_left.children[0].name;
                p_left.source = p_left.children[0].source;
                p_left.children = p_left.children[0].children;
            }
            else {
                if (p_left.children[0].textified) {
                    p_left.textified = p_left.children[0].textified;
                }
                if (p_left.children[0].isText) {
                    p_left.isText = true;
                    p_left.name = p_left.children[0].name;
                    p_left.source = p_left.children[0].source;
                    p_left.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property left undefined: ' + JSON.stringify(node));
    }
    console.log('BinaryExpression.p_left', p_left);
    // process AST-node-property right and set it in a var
    var p_right = null;
    if (node.right) {
        p_right = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.right.type) {
            throw 'Node right has no type: ' + JSON.stringify(node);
        }
        format(p_right, node.right, options);
        if (p_right.children.length == 1) {
            if (!(p_right.children[0].isText || p_right.children[0].textified)) {
                p_right.tag = p_right.children[0].tag;
                p_right.name = p_right.children[0].name;
                p_right.source = p_right.children[0].source;
                p_right.children = p_right.children[0].children;
            }
            else {
                if (p_right.children[0].textified) {
                    p_right.textified = p_right.children[0].textified;
                }
                if (p_right.children[0].isText) {
                    p_right.isText = true;
                    p_right.name = p_right.children[0].name;
                    p_right.source = p_right.children[0].source;
                    p_right.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property right undefined: ' + JSON.stringify(node));
    }
    console.log('BinaryExpression.p_right', p_right);
    if (isTextualNode(p_left) && isTextualNode(p_right)) {
        ret.tag = 'set';
        ret.name = getNodeText(p_left) + ' ' + node.operator + ' ' + getNodeText(p_right);
        ret.textified = ret.name;
        if (node.extra && node.extra.parenthesized == true) {
            ret.textified = '(' + ret.textified + ')';
        }
    }
    else {
        if (isTextualNode(p_left) || ['member-expr', 'ident', 'literal'].indexOf(p_left.tag) > -1) {
            p_left.tag = '+';
            if (isTextualNode(p_left)) {
                p_left.name = getNodeText(p_left);
                p_left.children = [];
            }
        }
        ret.children.push(p_left);
        if (isTextualNode(p_right) || ['member-expr', 'ident', 'literal'].indexOf(p_right.tag) > -1) {
            p_right.tag = '+';
            if (isTextualNode(p_right)) {
                p_right.name = getNodeText(p_right);
                p_right.children = [];
            }
        }
        ret.children.push(p_right);
        /**
            TODO VIA
            var test = isTextualNode(p_right);
            if (isTextualNode(p_left)) {
                ret.name = getNodeText(p_left);
                ret.children.splice(0, 1);
                if (node.extra && node.extra.parenthesized == true) {
                    ret.tag = ret.tag + '(';
                }
                if (test) {
                    p_left.tag = '@';
                }
            }
            else {
                if (test) {
                    p_right.tag = '@';
                    p_right.name = getNodeText(p_right);
                }
            }
        */
        if (node.__parent && node.__parent.name === 'body' && node.__parent.len == 1) {
            // is the return value of an ArrowExpression
            if (node.extra && node.extra.parenthesized == true) {
                ret.tag = '(';
            }
            else {
                ret.tag = '+';
            }
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node AssignmentExpression
format.AssignmentExpression = function(parent, node, options) {
    console.log('node : AssignmentExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'set', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // An assignment operator expression.
    // s( operator, AssignmentOperator
    // enum AssignmentOperator { "=" | "+=" | "-=" | "*=" | "/=" | "%=" | "<<=" | ">>=" | ">>>=" | "|=" | "^=" | "&="
    options.mustBeText = true;
    // process AST-node-property left and set it in a var
    var p_left = null;
    if (node.left) {
        p_left = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.left.type) {
            throw 'Node left has no type: ' + JSON.stringify(node);
        }
        format(p_left, node.left, options);
        if (p_left.children.length == 1) {
            if (!(p_left.children[0].isText || p_left.children[0].textified)) {
                p_left.tag = p_left.children[0].tag;
                p_left.name = p_left.children[0].name;
                p_left.source = p_left.children[0].source;
                p_left.children = p_left.children[0].children;
            }
            else {
                if (p_left.children[0].textified) {
                    p_left.textified = p_left.children[0].textified;
                }
                if (p_left.children[0].isText) {
                    p_left.isText = true;
                    p_left.name = p_left.children[0].name;
                    p_left.source = p_left.children[0].source;
                    p_left.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property left undefined: ' + JSON.stringify(node));
    }
    options.mustBeText = false;
    // process AST-node-property right and set it in a var
    var p_right = null;
    if (node.right) {
        p_right = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.right.type) {
            throw 'Node right has no type: ' + JSON.stringify(node);
        }
        format(p_right, node.right, options);
        if (p_right.children.length == 1) {
            if (!(p_right.children[0].isText || p_right.children[0].textified)) {
                p_right.tag = p_right.children[0].tag;
                p_right.name = p_right.children[0].name;
                p_right.source = p_right.children[0].source;
                p_right.children = p_right.children[0].children;
            }
            else {
                if (p_right.children[0].textified) {
                    p_right.textified = p_right.children[0].textified;
                }
                if (p_right.children[0].isText) {
                    p_right.isText = true;
                    p_right.name = p_right.children[0].name;
                    p_right.source = p_right.children[0].source;
                    p_right.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property right undefined: ' + JSON.stringify(node));
    }
    ret.name = getNodeText(p_left) + ' ' + node.operator + ' ';
    if (isTextualNode(p_right)) {
        ret.name += getNodeText(p_right);
    }
    else {
        ret.children.push(p_right);
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node LogicalExpression
format.LogicalExpression = function(parent, node, options) {
    options.mustBeText = true;
    console.log('node : LogicalExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'op' + node.operator, 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A logical operator expression.
    // s( operator, LogicalOperator enum "||" | "&&" | "??"
    // process AST-node-property left and set it in a var
    var p_left = null;
    if (node.left) {
        p_left = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.left.type) {
            throw 'Node left has no type: ' + JSON.stringify(node);
        }
        format(p_left, node.left, options);
        if (p_left.children.length == 1) {
            if (!(p_left.children[0].isText || p_left.children[0].textified)) {
                p_left.tag = p_left.children[0].tag;
                p_left.name = p_left.children[0].name;
                p_left.source = p_left.children[0].source;
                p_left.children = p_left.children[0].children;
            }
            else {
                if (p_left.children[0].textified) {
                    p_left.textified = p_left.children[0].textified;
                }
                if (p_left.children[0].isText) {
                    p_left.isText = true;
                    p_left.name = p_left.children[0].name;
                    p_left.source = p_left.children[0].source;
                    p_left.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property left undefined: ' + JSON.stringify(node));
    }
    // process AST-node-property right and set it in a var
    var p_right = null;
    if (node.right) {
        p_right = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.right.type) {
            throw 'Node right has no type: ' + JSON.stringify(node);
        }
        format(p_right, node.right, options);
        if (p_right.children.length == 1) {
            if (!(p_right.children[0].isText || p_right.children[0].textified)) {
                p_right.tag = p_right.children[0].tag;
                p_right.name = p_right.children[0].name;
                p_right.source = p_right.children[0].source;
                p_right.children = p_right.children[0].children;
            }
            else {
                if (p_right.children[0].textified) {
                    p_right.textified = p_right.children[0].textified;
                }
                if (p_right.children[0].isText) {
                    p_right.isText = true;
                    p_right.name = p_right.children[0].name;
                    p_right.source = p_right.children[0].source;
                    p_right.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property right undefined: ' + JSON.stringify(node));
    }
    if (isTextualNode(p_left) && isTextualNode(p_right)) {
        ret.tag = 'set';
        ret.name = getNodeText(p_left) + ' ' + node.operator + ' ' + getNodeText(p_right);
        ret.textified = ret.name;
    }
    else {
        ret.tag = node.operator;
        if (isTextualNode(p_left) || ['member-expr', 'ident', 'literal'].indexOf(p_left.tag) > -1) {
            p_left.tag = '+';
            if (isTextualNode(p_left)) {
                p_left.name = getNodeText(p_left);
                p_left.children = [];
            }
        }
        ret.children.push(p_left);
        console.log('LogicalExpression.p_left', p_left);
        if (isTextualNode(p_right) || ['member-expr', 'ident', 'literal'].indexOf(p_right.tag) > -1) {
            p_right.tag = '+';
            if (isTextualNode(p_right)) {
                p_right.name = getNodeText(p_right);
                p_right.children = [];
            }
        }
        ret.children.push(p_right);
        console.log('LogicalExpression.p_right', p_right);
    }
    if (node.__parent && node.__parent.name === 'body' && node.__parent.len == 1) {
        // is the return value of an ArrowExpression
        if (node.extra && node.extra.parenthesized == true) {
            if (ret.tag === 'set') {
                ret.tag = '(';
            }
            else {
                ret.tag = '(' + ret.tag;
            }
        }
        else {
            if (ret.tag === 'set') {
                ret.tag = '+';
            }
            else {
                // TODO Do nothing is OK?
            }
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
        options.mustBeText = false;
    }
};
// process AST node SpreadElement
format.SpreadElement = function(parent, node, options) {
    console.log('node : SpreadElement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '...', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property argument and set it in a var
    var p_argument = null;
    if (node.argument) {
        p_argument = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.argument.type) {
            throw 'Node argument has no type: ' + JSON.stringify(node);
        }
        format(p_argument, node.argument, options);
        if (p_argument.children.length == 1) {
            if (!(p_argument.children[0].isText || p_argument.children[0].textified)) {
                p_argument.tag = p_argument.children[0].tag;
                p_argument.name = p_argument.children[0].name;
                p_argument.source = p_argument.children[0].source;
                p_argument.children = p_argument.children[0].children;
            }
            else {
                if (p_argument.children[0].textified) {
                    p_argument.textified = p_argument.children[0].textified;
                }
                if (p_argument.children[0].isText) {
                    p_argument.isText = true;
                    p_argument.name = p_argument.children[0].name;
                    p_argument.source = p_argument.children[0].source;
                    p_argument.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property argument undefined: ' + JSON.stringify(node));
    }
    if (isTextualNode(p_argument)) {
        ret.name = getNodeText(p_argument);
        ret.textified = '...' + ret.name;
    }
    else {
        throw new Error('SpreadElement must be textual:' + p_callee.children[0].tag);
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node MemberExpression
format.MemberExpression = function(parent, node, options) {
    console.log('node : MemberExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'member-expr', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property object and set it in a var
    var p_object = null;
    if (node.object) {
        p_object = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.object.type) {
            throw 'Node object has no type: ' + JSON.stringify(node);
        }
        format(p_object, node.object, options);
        if (p_object.children.length == 1) {
            if (!(p_object.children[0].isText || p_object.children[0].textified)) {
                p_object.tag = p_object.children[0].tag;
                p_object.name = p_object.children[0].name;
                p_object.source = p_object.children[0].source;
                p_object.children = p_object.children[0].children;
            }
            else {
                if (p_object.children[0].textified) {
                    p_object.textified = p_object.children[0].textified;
                }
                if (p_object.children[0].isText) {
                    p_object.isText = true;
                    p_object.name = p_object.children[0].name;
                    p_object.source = p_object.children[0].source;
                    p_object.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property object undefined: ' + JSON.stringify(node));
    }
    // process AST-node-property property and set it in a var
    var p_property = null;
    if (node.property) {
        p_property = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.property.type) {
            throw 'Node property has no type: ' + JSON.stringify(node);
        }
        format(p_property, node.property, options);
        if (p_property.children.length == 1) {
            if (!(p_property.children[0].isText || p_property.children[0].textified)) {
                p_property.tag = p_property.children[0].tag;
                p_property.name = p_property.children[0].name;
                p_property.source = p_property.children[0].source;
                p_property.children = p_property.children[0].children;
            }
            else {
                if (p_property.children[0].textified) {
                    p_property.textified = p_property.children[0].textified;
                }
                if (p_property.children[0].isText) {
                    p_property.isText = true;
                    p_property.name = p_property.children[0].name;
                    p_property.source = p_property.children[0].source;
                    p_property.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property property undefined: ' + JSON.stringify(node));
    }
    // b( computed
    // b( optional, optional
    // If `computed` is `true`, the node corresponds to a computed (`a[b]`) member expression and `property` is an `Expression`.
    // If `computed` is `false`, the node corresponds to a static (`a.b`) member expression and `property` is an `Identifier`.
    // The `optional` flags indicates that the member expression can be called even if the object is null or undefined.
    // If this is the object value (null/undefined) should be returned.
    if (isTextualNode(p_object)) {
        var obj = getNodeText(p_object);
        if (isTextualNode(p_property)) {
            var prop = getNodeText(p_property);
            ret.name = node.computed ? obj + '[' + prop + ']' : obj + '.' + prop;
            ret.textified = ret.name;
            ret.children = [];
            console.log('MemberExpression.textified', ret.textified);
        }
        else {
            ret.name = obj;
            var link = {
                tag: node.computed ? '.[' : '.', 
                children: [
                    
                ]
            };
            link.children.push(p_property);
            ret.children.push(link);
        }
    }
    else {
        if (node.computed) {
            p_property.tag = '.[';
        }
        else {
            p_property.tag = '.';
        }
        ret.tag = p_object.tag;
        ret.name = p_object.name;
        ret.source = p_object.source;
        ret.children = p_object.children;
        ret.children.push(p_property);
        console.log('MemberExpression.tag.name', ret.tag, ret.name);
        var i, i_items=ret.children, i_len=ret.children.length, item;
        for (i=0; i<i_len; i++) {
            item = ret.children[i];
            console.log('MemberExpression.child', i, ret.children[i].tag, ret.children[i].name);
        }
    }
    if (node.__parent && node.__parent.name === 'body' && node.__parent.len == 1) {
        // is the return value of an ArrowExpression
        if (node.extra && node.extra.parenthesized == true) {
            ret.tag = '(';
        }
        else {
            ret.tag = '+';
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node BindExpression
format.BindExpression = function(parent, node, options) {
    console.log('node : BindExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'bind-expr', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property object and append ittfNode to `ret`
    if (node.object) {
        if (!node.object.type) {
            throw 'Node object has no type: ' + JSON.stringify(node);
        }
        format(ret, node.object, options);
    }
    // process AST-node-property callee and append ittfNode to `ret`
    if (node.callee) {
        if (!node.callee.type) {
            throw 'Node callee has no type: ' + JSON.stringify(node);
        }
        format(ret, node.callee, options);
    }
    else {
        throw new Error('AST-node-property callee undefined: ' + JSON.stringify(node));
    }
    // if `object` is `null`, then `callee` should be a `MemberExpression`.
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ConditionalExpression
format.ConditionalExpression = function(parent, node, options) {
    console.log('node : ConditionalExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'iif', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A conditional expression, i.e., a ternary `?`/`,` expression.
    var p_test = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.test) {
        if (!node.test.type) {
            throw 'Node test has no type: ' + JSON.stringify(node);
        }
        format(p_test, node.test, options);
        p_test.tag = 'test';
        ret.children.push(p_test);
        if (p_test.children.length == 1) {
            console.log('*** f_p_tag test children[0].textified', p_test.children[0].textified);
            console.log('*** f_p_tag test children[0].isText', p_test.children[0].isText);
            console.log('*** f_p_tag test children[0].name', p_test.children[0].name);
            if (p_test.children[0].textified) {
                p_test.textified = p_test.children[0].textified;
            }
            if (p_test.children[0].isText) {
                p_test.isText = true;
                p_test.name = p_test.children[0].name;
                p_test.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property test/test not managed by f_p_tag');
            }
        */
    }
    // process AST-node-property consequent and set it in a var
    var p_consequent = null;
    if (node.consequent) {
        p_consequent = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.consequent.type) {
            throw 'Node consequent has no type: ' + JSON.stringify(node);
        }
        format(p_consequent, node.consequent, options);
        if (p_consequent.children.length == 1) {
            if (!(p_consequent.children[0].isText || p_consequent.children[0].textified)) {
                p_consequent.tag = p_consequent.children[0].tag;
                p_consequent.name = p_consequent.children[0].name;
                p_consequent.source = p_consequent.children[0].source;
                p_consequent.children = p_consequent.children[0].children;
            }
            else {
                if (p_consequent.children[0].textified) {
                    p_consequent.textified = p_consequent.children[0].textified;
                }
                if (p_consequent.children[0].isText) {
                    p_consequent.isText = true;
                    p_consequent.name = p_consequent.children[0].name;
                    p_consequent.source = p_consequent.children[0].source;
                    p_consequent.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property consequent undefined: ' + JSON.stringify(node));
    }
    // process AST-node-property alternate and set it in a var
    var p_alternate = null;
    if (node.alternate) {
        p_alternate = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.alternate.type) {
            throw 'Node alternate has no type: ' + JSON.stringify(node);
        }
        format(p_alternate, node.alternate, options);
        if (p_alternate.children.length == 1) {
            if (!(p_alternate.children[0].isText || p_alternate.children[0].textified)) {
                p_alternate.tag = p_alternate.children[0].tag;
                p_alternate.name = p_alternate.children[0].name;
                p_alternate.source = p_alternate.children[0].source;
                p_alternate.children = p_alternate.children[0].children;
            }
            else {
                if (p_alternate.children[0].textified) {
                    p_alternate.textified = p_alternate.children[0].textified;
                }
                if (p_alternate.children[0].isText) {
                    p_alternate.isText = true;
                    p_alternate.name = p_alternate.children[0].name;
                    p_alternate.source = p_alternate.children[0].source;
                    p_alternate.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property alternate undefined: ' + JSON.stringify(node));
    }
    setNameFromChildByTag(ret, 'test', true);
    if (isTextualNode(p_consequent)) {
        ret.children.push({
            tag: 'then', 
            name: getNodeText(p_consequent), 
            children: [
                
            ]
        });
    }
    else {
        ret.children.push({
            tag: 'then', 
            children: [
                p_consequent
            ]
        });
    }
    if (isTextualNode(p_alternate)) {
        ret.children.push({
            tag: 'else', 
            name: getNodeText(p_alternate), 
            children: [
                
            ]
        });
    }
    else {
        ret.children.push({
            tag: 'else', 
            children: [
                p_alternate
            ]
        });
    }
    if (node.__parent && node.__parent.name === 'body' && node.__parent.len == 1) {
        // is the return value of an ArrowExpression
        if (node.extra && node.extra.parenthesized == true) {
            var temp = {
                tag: '(', 
                children: [
                    ret
                ]
            };
            ret = temp;
        }
        else {
            // TODO do nothing
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node CallExpression
format.CallExpression = function(parent, node, options) {
    console.log('node : CallExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '_', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A function or method call expression.
    // process AST-node-property callee and set it in a var
    var p_callee = null;
    if (node.callee) {
        p_callee = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.callee.type) {
            throw 'Node callee has no type: ' + JSON.stringify(node);
        }
        format(p_callee, node.callee, options);
        if (p_callee.children.length == 1) {
            if (!(p_callee.children[0].isText || p_callee.children[0].textified)) {
                p_callee.tag = p_callee.children[0].tag;
                p_callee.name = p_callee.children[0].name;
                p_callee.source = p_callee.children[0].source;
                p_callee.children = p_callee.children[0].children;
            }
            else {
                if (p_callee.children[0].textified) {
                    p_callee.textified = p_callee.children[0].textified;
                }
                if (p_callee.children[0].isText) {
                    p_callee.isText = true;
                    p_callee.name = p_callee.children[0].name;
                    p_callee.source = p_callee.children[0].source;
                    p_callee.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property callee undefined: ' + JSON.stringify(node));
    }
    // process AST-node-property-collection arguments and
    // embed its array of nodes in a new tag
    if (node.arguments) {
        if (typeof node.arguments.length === 'undefined') {
            throw new Error('Property node.arguments must be an array');
        }
        if (node.arguments.length > 0) {
            var temparguments = {
                tag: 'arguments', 
                children: [
                    
                ]
            };
            var i, i_items=node.arguments, i_len=node.arguments.length, item;
            for (i=0; i<i_len; i++) {
                item = node.arguments[i];
                item.__parent = {
                    name: 'arguments', 
                    len: node.arguments.length
                };
                format(temparguments, item, options);
            }
            ret.children.push(temparguments);
        }
    }
    var lastCallee = ret;
    var argumentsNode = getChildByTag(ret, 'arguments');
    ret.children = [];
    // log 'p_callee', p_callee
    // first of all try to set ret.textified
    if (isTextualNode(p_callee)) {
        ret.name = getNodeText(p_callee);
        if (argumentsNode) {
            var tlist = getTextList(argumentsNode, ', ');
            if (tlist) {
                ret.name += '(' + tlist + ')';
                ret.textified = ret.name;
            }
            else {
                var i, i_items=argumentsNode.children, i_len=argumentsNode.children.length, item;
                for (i=0; i<i_len; i++) {
                    item = argumentsNode.children[i];
                    if (['member-expr', 'ident', 'literal'].indexOf(item.tag) > -1) {
                        item.tag = '@';
                    }
                    lastCallee.children.push(item);
                }
            }
        }
        else {
            ret.textified = ret.name + '()';
        }
        if (ret.textified && node.extra && node.extra.parenthesized == true) {
            ret.textified = '(' + ret.textified + ')';
        }
        console.log('CallExpression', 'ret.name,textified', ret.name, ret.textified);
    }
    else {
        console.log('CallExpression', 'p_callee.tag.name', p_callee.tag, p_callee.name);
        var i, i_items=p_callee.children, i_len=p_callee.children.length, item;
        for (i=0; i<i_len; i++) {
            item = p_callee.children[i];
            console.log('CallExpression', 'p_callee.children', i, p_callee.children[i].tag, p_callee.children[i].name);
        }
        if (argumentsNode) {
            var i, i_items=argumentsNode.children, i_len=argumentsNode.children.length, item;
            for (i=0; i<i_len; i++) {
                item = argumentsNode.children[i];
                console.log('CallExpression', 'argumentsNode.children', i, argumentsNode.children[i].tag, argumentsNode.children[i].name);
            }
        }
        if (['[', '{'].indexOf(p_callee.tag) > -1) {
            ret.tag = p_callee.tag;
        }
        ret.name = p_callee.name;
        ret.children = p_callee.children;
        lastCallee = p_callee.children[p_callee.children.length-1];
        if (argumentsNode && argumentsNode.children.length > 0) {
            if (lastCallee.tag === '.') {
                lastCallee.tag = '._';
                var i, i_items=argumentsNode.children, i_len=argumentsNode.children.length, item;
                for (i=0; i<i_len; i++) {
                    item = argumentsNode.children[i];
                    if (['member-expr', 'ident', 'literal'].indexOf(item.tag) > -1) {
                        item.tag = '@';
                    }
                    lastCallee.children.push(item);
                }
            }
            else {
                var call = {
                    tag: '(', 
                    children: [
                        
                    ]
                };
                var i, i_items=argumentsNode.children, i_len=argumentsNode.children.length, item;
                for (i=0; i<i_len; i++) {
                    item = argumentsNode.children[i];
                    if (['member-expr', 'ident', 'literal'].indexOf(item.tag) > -1) {
                        item.tag = '@';
                    }
                    call.children.push(item);
                }
                ret.children.push(call);
            }
        }
        else {
            if (lastCallee.tag === '.') {
                lastCallee.tag = '._';
            }
        }
    }
    if (node.extra && node.extra.parenthesized == true) {
        var temp = {
            tag: '(', 
            children: [
                ret
            ]
        };
        ret = temp;
    }
    // log 'CallExpression.exit.ret', ret
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node NewExpression
format.NewExpression = function(parent, node, options) {
    options.couldBeText = true;
    console.log('node : NewExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'new', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property-collection arguments and
    // embed its array of nodes in a new tag
    if (node.arguments) {
        if (typeof node.arguments.length === 'undefined') {
            throw new Error('Property node.arguments must be an array');
        }
        if (node.arguments.length > 0) {
            var temparguments = {
                tag: 'arguments', 
                children: [
                    
                ]
            };
            var i, i_items=node.arguments, i_len=node.arguments.length, item;
            for (i=0; i<i_len; i++) {
                item = node.arguments[i];
                item.__parent = {
                    name: 'arguments', 
                    len: node.arguments.length
                };
                format(temparguments, item, options);
            }
            ret.children.push(temparguments);
        }
    }
    // process AST-node-property callee and set it in a var
    var p_callee = null;
    if (node.callee) {
        p_callee = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.callee.type) {
            throw 'Node callee has no type: ' + JSON.stringify(node);
        }
        format(p_callee, node.callee, options);
        if (p_callee.children.length == 1) {
            if (!(p_callee.children[0].isText || p_callee.children[0].textified)) {
                p_callee.tag = p_callee.children[0].tag;
                p_callee.name = p_callee.children[0].name;
                p_callee.source = p_callee.children[0].source;
                p_callee.children = p_callee.children[0].children;
            }
            else {
                if (p_callee.children[0].textified) {
                    p_callee.textified = p_callee.children[0].textified;
                }
                if (p_callee.children[0].isText) {
                    p_callee.isText = true;
                    p_callee.name = p_callee.children[0].name;
                    p_callee.source = p_callee.children[0].source;
                    p_callee.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property callee undefined: ' + JSON.stringify(node));
    }
    if (p_callee.isText || p_callee.textified) {
        ret.name = p_callee.textified || p_callee.name;
    }
    else {
        throw new Error('NewExpression.callee must be textual:' + p_callee.children[0].tag);
    }
    var argumentsNode = getChildByTag(ret, 'arguments');
    ret.children = [];
    if (argumentsNode) {
        var tlist = getTextList(argumentsNode, ', ');
        console.log('NewExpression.tlist', tlist);
        // if tlist && tlist.length < 15
        if (tlist) {
            ret.name += '(' + tlist + ')';
            ret.textified = 'new ' + ret.name;
        }
        else {
            var i, i_items=argumentsNode.children, i_len=argumentsNode.children.length, item;
            for (i=0; i<i_len; i++) {
                item = argumentsNode.children[i];
                if (['member-expr', 'ident', 'literal'].indexOf(item.tag) > -1) {
                    item.tag = '@';
                }
                ret.children.push(item);
            }
        }
    }
    else {
        ret.textified = ret.name + '()';
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
        options.couldBeText = false;
    }
};
// process AST node SequenceExpression
format.SequenceExpression = function(parent, node, options) {
    console.log('node : SequenceExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'sequence', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property-collection expressions and append ittfNode(s) to `ret`
    if (node.expressions) {
        if (typeof node.expressions.length === 'undefined') {
            throw new Error('Property node.expressions must be an array');
        }
        var i, i_items=node.expressions, i_len=node.expressions.length, item;
        for (i=0; i<i_len; i++) {
            item = node.expressions[i];
            item.__parent = {
                name: 'expressions', 
                len: node.expressions.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection expressions undefined: ' + JSON.stringify(node));
    }
    // A sequence expression, i.e., a comma-separated sequence of expressions.
    var i, i_items=ret.children, i_len=ret.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ret.children[i];
        if (['member-expr', 'ident', 'literal'].indexOf(item.tag) > -1) {
            item.tag = 'set';
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node DoExpression
format.DoExpression = function(parent, node, options) {
    console.log('node : DoExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'do', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node TemplateLiteral
format.TemplateLiteral = function(parent, node, options) {
    console.log('node : TemplateLiteral ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '`lit', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property-collection quasis and
    // embed its array of nodes in a temp var
    if (node.quasis) {
        if (typeof node.quasis.length === 'undefined') {
            throw new Error('Property node.quasis must be an array');
        }
        var p_quasis = {
            tag: 'true', 
            children: [
                
            ]
        };
        var i, i_items=node.quasis, i_len=node.quasis.length, item;
        for (i=0; i<i_len; i++) {
            item = node.quasis[i];
            item.__parent = {
                name: 'quasis', 
                len: node.quasis.length
            };
            format(p_quasis, item, options);
        }
    }
    // process AST-node-property-collection expressions and
    // embed its array of nodes in a temp var
    if (node.expressions) {
        if (typeof node.expressions.length === 'undefined') {
            throw new Error('Property node.expressions must be an array');
        }
        var p_expressions = {
            tag: 'true', 
            children: [
                
            ]
        };
        var i, i_items=node.expressions, i_len=node.expressions.length, item;
        for (i=0; i<i_len; i++) {
            item = node.expressions[i];
            item.__parent = {
                name: 'expressions', 
                len: node.expressions.length
            };
            format(p_expressions, item, options);
        }
    }
    var i = 0;
    for (i = 0; i < p_expressions.children.length; i++) {
        var q = p_quasis.children[i];
        if (q.name.length > 0) {
            ret.children.push(q);
        }
        var e = p_expressions.children[i];
        if (['member-expr', 'ident', 'literal'].indexOf(e.tag) > -1) {
            e.tag = '@';
        }
        console.log('TemplateLiteral.e', e);
        ret.children.push(e);
    }
    if (p_quasis.children[i] && p_quasis.children[i].name.length > 0) {
        ret.children.push(p_quasis.children[i]);
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node TaggedTemplateExpression
format.TaggedTemplateExpression = function(parent, node, options) {
    console.log('node : TaggedTemplateExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '`tag', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property tag and set it in a var
    var p_tag = null;
    if (node.tag) {
        p_tag = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.tag.type) {
            throw 'Node tag has no type: ' + JSON.stringify(node);
        }
        format(p_tag, node.tag, options);
        if (p_tag.children.length == 1) {
            if (!(p_tag.children[0].isText || p_tag.children[0].textified)) {
                p_tag.tag = p_tag.children[0].tag;
                p_tag.name = p_tag.children[0].name;
                p_tag.source = p_tag.children[0].source;
                p_tag.children = p_tag.children[0].children;
            }
            else {
                if (p_tag.children[0].textified) {
                    p_tag.textified = p_tag.children[0].textified;
                }
                if (p_tag.children[0].isText) {
                    p_tag.isText = true;
                    p_tag.name = p_tag.children[0].name;
                    p_tag.source = p_tag.children[0].source;
                    p_tag.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property tag undefined: ' + JSON.stringify(node));
    }
    if (isTextualNode(p_tag)) {
        ret.name = getNodeText(p_tag);
    }
    else {
        throw new Error('TaggedTemplateExpression.tag must be textual:' + JSON.stringify(node));
    }
    // process AST-node-property quasi and set it in a var
    var p_quasi = null;
    if (node.quasi) {
        p_quasi = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.quasi.type) {
            throw 'Node quasi has no type: ' + JSON.stringify(node);
        }
        format(p_quasi, node.quasi, options);
        if (p_quasi.children.length == 1) {
            if (!(p_quasi.children[0].isText || p_quasi.children[0].textified)) {
                p_quasi.tag = p_quasi.children[0].tag;
                p_quasi.name = p_quasi.children[0].name;
                p_quasi.source = p_quasi.children[0].source;
                p_quasi.children = p_quasi.children[0].children;
            }
            else {
                if (p_quasi.children[0].textified) {
                    p_quasi.textified = p_quasi.children[0].textified;
                }
                if (p_quasi.children[0].isText) {
                    p_quasi.isText = true;
                    p_quasi.name = p_quasi.children[0].name;
                    p_quasi.source = p_quasi.children[0].source;
                    p_quasi.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property quasi undefined: ' + JSON.stringify(node));
    }
    var i, i_items=p_quasi.children, i_len=p_quasi.children.length, item;
    for (i=0; i<i_len; i++) {
        item = p_quasi.children[i];
        ret.children.push(item);
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node TemplateElement
format.TemplateElement = function(parent, node, options) {
    console.log('node : TemplateElement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '+', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // b( tail
    ret.name = verify.replaceAll(verify.replaceAll(node.value.raw, '\n', '\\n'), ' ', '\\b');
    // f_p( value
    // f_p_p( value, cooked, optional
    // f_p_p( value, raw
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ObjectPattern
format.ObjectPattern = function(parent, node, options) {
    console.log('node : ObjectPattern ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '{', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property-collection properties and append ittfNode(s) to `ret`
    if (node.properties) {
        if (typeof node.properties.length === 'undefined') {
            throw new Error('Property node.properties must be an array');
        }
        var i, i_items=node.properties, i_len=node.properties.length, item;
        for (i=0; i<i_len; i++) {
            item = node.properties[i];
            item.__parent = {
                name: 'properties', 
                len: node.properties.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection properties undefined: ' + JSON.stringify(node));
    }
    if (options.mustBeText) {
        if (setTextList(ret, ', ')) {
            ret.textified = '{' + ret.textified + '}';
            if (node.extra && node.extra.parenthesized == true) {
                ret.textified = '(' + ret.textified + ')';
            }
        }
        else {
            throw new Error("ObjectPattern. Cannot textify node as requested: " + JSON.stringify(node));
        }
    }
    else {
        if (ret.children.length == 0) {
            if (node.extra && node.extra.parenthesized == true) {
                ret.name = ret.textified = '({})';
            }
            else {
                ret.name = ret.textified = '{}';
            }
        }
        else {
            if (node.extra && node.extra.parenthesized == true) {
                var temp = {
                    tag: '(', 
                    children: [
                        ret
                    ]
                };
                ret = temp;
            }
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ArrayPattern
format.ArrayPattern = function(parent, node, options) {
    console.log('node : ArrayPattern ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property-collection elements and append ittfNode(s) to `ret`
    if (node.elements) {
        if (typeof node.elements.length === 'undefined') {
            throw new Error('Property node.elements must be an array');
        }
        var i, i_items=node.elements, i_len=node.elements.length, item;
        for (i=0; i<i_len; i++) {
            item = node.elements[i];
            item.__parent = {
                name: 'elements', 
                len: node.elements.length
            };
            format(ret, item, options);
        }
    }
    if (setTextList(ret, ', ')) {
        ret.textified = '[' + ret.textified + ']';
        console.log('*** ArrayPattern len, textified: ', ret.children.length, ret.textified);
    }
    else {
        throw new Error('ArrayPattern must be textual: ' + JSON.stringify(node));
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node RestElement
format.RestElement = function(parent, node, options) {
    console.log('node : RestElement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '...', 
        name: '', 
        isText: true, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property argument and append ittfNode to `ret`
    if (node.argument) {
        if (!node.argument.type) {
            throw 'Node argument has no type: ' + JSON.stringify(node);
        }
        format(ret, node.argument, options);
    }
    else {
        throw new Error('AST-node-property argument undefined: ' + JSON.stringify(node));
    }
    console.log('get_text_from_1_children', isChildrenCount(ret, 1));
    var got_text_1 = false;
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified || ret.children[0].isText) {
            var c1 = ret.children[0].textified || ret.children[0].name;
            ret.name = c1;
            ret.textified = ret.name;
            ret.children = [];
            got_text_1 = true;
        }
    }
    ret.name = '...' + ret.name;
    if (ret != null) {
        ret.textified = ret.name;
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node AssignmentPattern
format.AssignmentPattern = function(parent, node, options) {
    console.log('node : AssignmentPattern ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property left and set it in a var
    var p_left = null;
    if (node.left) {
        p_left = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.left.type) {
            throw 'Node left has no type: ' + JSON.stringify(node);
        }
        format(p_left, node.left, options);
        if (p_left.children.length == 1) {
            if (!(p_left.children[0].isText || p_left.children[0].textified)) {
                p_left.tag = p_left.children[0].tag;
                p_left.name = p_left.children[0].name;
                p_left.source = p_left.children[0].source;
                p_left.children = p_left.children[0].children;
            }
            else {
                if (p_left.children[0].textified) {
                    p_left.textified = p_left.children[0].textified;
                }
                if (p_left.children[0].isText) {
                    p_left.isText = true;
                    p_left.name = p_left.children[0].name;
                    p_left.source = p_left.children[0].source;
                    p_left.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property left undefined: ' + JSON.stringify(node));
    }
    // process AST-node-property right and set it in a var
    var p_right = null;
    if (node.right) {
        p_right = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.right.type) {
            throw 'Node right has no type: ' + JSON.stringify(node);
        }
        format(p_right, node.right, options);
        if (p_right.children.length == 1) {
            if (!(p_right.children[0].isText || p_right.children[0].textified)) {
                p_right.tag = p_right.children[0].tag;
                p_right.name = p_right.children[0].name;
                p_right.source = p_right.children[0].source;
                p_right.children = p_right.children[0].children;
            }
            else {
                if (p_right.children[0].textified) {
                    p_right.textified = p_right.children[0].textified;
                }
                if (p_right.children[0].isText) {
                    p_right.isText = true;
                    p_right.name = p_right.children[0].name;
                    p_right.source = p_right.children[0].source;
                    p_right.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property right undefined: ' + JSON.stringify(node));
    }
    if (isTextualNode(p_left)) {
        ret.name = getNodeText(p_left) + ' ' + node.operator + ' ';
    }
    if (isTextualNode(p_right)) {
        ret.name += getNodeText(p_right);
    }
    else {
        ret.children.push(p_right);
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node Class
format.Class = function(parent, node, options) {
    console.log('node : Class ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'class', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Process AST-node-property id and
    // set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.id) {
        if (!node.id.type) {
            throw 'Node id has no type: ' + JSON.stringify(node);
        }
        var tempid = {
            children: [
                
            ]
        };
        format(tempid, node.id, options);
        /**
            if (tempid .children.length > 0) {
                throw 'node.id must result zero node, returned: ' + tempid.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempid.children.length > 0) {
            appto.name = tempid.children[0].name;
        }
        else {
            appto.name = tempid.name;
        }
    }
    // process AST-node-property superClass and set it in a var
    var p_superClass = null;
    if (node.superClass) {
        p_superClass = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.superClass.type) {
            throw 'Node superClass has no type: ' + JSON.stringify(node);
        }
        format(p_superClass, node.superClass, options);
        if (p_superClass.children.length == 1) {
            if (!(p_superClass.children[0].isText || p_superClass.children[0].textified)) {
                p_superClass.tag = p_superClass.children[0].tag;
                p_superClass.name = p_superClass.children[0].name;
                p_superClass.source = p_superClass.children[0].source;
                p_superClass.children = p_superClass.children[0].children;
            }
            else {
                if (p_superClass.children[0].textified) {
                    p_superClass.textified = p_superClass.children[0].textified;
                }
                if (p_superClass.children[0].isText) {
                    p_superClass.isText = true;
                    p_superClass.name = p_superClass.children[0].name;
                    p_superClass.source = p_superClass.children[0].source;
                    p_superClass.children = [];
                }
            }
        }
    }
    if (p_superClass) {
        if (isTextualNode(p_superClass)) {
            ret.children.push({
                tag: 'super', 
                name: getNodeText(p_superClass)
            });
        }
        else {
            throw new Error('Class. superClass must be textual: ' + JSON.stringify(node));
        }
    }
    // process AST-node-property-collection decorators and append ittfNode(s) to `ret`
    if (node.decorators) {
        if (typeof node.decorators.length === 'undefined') {
            throw new Error('Property node.decorators must be an array');
        }
        var i, i_items=node.decorators, i_len=node.decorators.length, item;
        for (i=0; i<i_len; i++) {
            item = node.decorators[i];
            item.__parent = {
                name: 'decorators', 
                len: node.decorators.length
            };
            format(ret, item, options);
        }
    }
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ClassBody
format.ClassBody = function(parent, node, options) {
    console.log('node : ClassBody ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = parent;
    // process AST-node-property-collection body and append ittfNode(s) to `ret`
    if (node.body) {
        if (typeof node.body.length === 'undefined') {
            throw new Error('Property node.body must be an array');
        }
        var i, i_items=node.body, i_len=node.body.length, item;
        for (i=0; i<i_len; i++) {
            item = node.body[i];
            item.__parent = {
                name: 'body', 
                len: node.body.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection body undefined: ' + JSON.stringify(node));
    }
    if (ret != null) {
    }
};
// process AST node ClassMethod
format.ClassMethod = function(parent, node, options) {
    console.log('node : ClassMethod ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: node.kind, 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_key = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.key) {
        if (!node.key.type) {
            throw 'Node key has no type: ' + JSON.stringify(node);
        }
        format(p_key, node.key, options);
        p_key.tag = 'key';
        ret.children.push(p_key);
        if (p_key.children.length == 1) {
            console.log('*** f_p_tag key children[0].textified', p_key.children[0].textified);
            console.log('*** f_p_tag key children[0].isText', p_key.children[0].isText);
            console.log('*** f_p_tag key children[0].name', p_key.children[0].name);
            if (p_key.children[0].textified) {
                p_key.textified = p_key.children[0].textified;
            }
            if (p_key.children[0].isText) {
                p_key.isText = true;
                p_key.name = p_key.children[0].name;
                p_key.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property key/key not managed by f_p_tag');
            }
        */
    }
    // s( kind
    // enum "constructor" | "method" | "get" | "set"
    // b( computed
    console.log('node.static', node.static);
    if (!!node.static == true) {
        ret.children.push({
            tag: 'static', 
            children: [
                
            ]
        });
    }
    // b( generator
    // b( async
    // process AST-node-property-collection decorators and append ittfNode(s) to `ret`
    if (node.decorators) {
        if (typeof node.decorators.length === 'undefined') {
            throw new Error('Property node.decorators must be an array');
        }
        var i, i_items=node.decorators, i_len=node.decorators.length, item;
        for (i=0; i<i_len; i++) {
            item = node.decorators[i];
            item.__parent = {
                name: 'decorators', 
                len: node.decorators.length
            };
            format(ret, item, options);
        }
    }
    // process AST-node-property-collection params and
    // embed its array of nodes in a new tag
    if (node.params) {
        if (typeof node.params.length === 'undefined') {
            throw new Error('Property node.params must be an array');
        }
        if (node.params.length > 0) {
            var tempparams = {
                tag: 'params', 
                children: [
                    
                ]
            };
            var i, i_items=node.params, i_len=node.params.length, item;
            for (i=0; i<i_len; i++) {
                item = node.params[i];
                item.__parent = {
                    name: 'params', 
                    len: node.params.length
                };
                format(tempparams, item, options);
            }
            ret.children.push(tempparams);
        }
    }
    processParams(ret);
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    ret.tag = ret.tag == 'constructor' ? 'ctor' : (ret.tag == 'method' ? 'm' : ret.tag);
    if (node.async) {
        ret.tag = 'async-' + ret.tag;
    }
    setNameFromChildByTag(ret, 'key', true);
    if (ret.tag === 'ctor') {
        ret.name = '';
    }
    else if (node.computed) {
        ret.name = '[' + ret.name + ']';
    }
    /**
        VIA
        replaceChildrenOfChildWhenText(ret, getChildPosByTag(ret, 'params'), 'param')*/
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ClassPrivateMethod
format.ClassPrivateMethod = function(parent, node, options) {
    console.log('node : ClassPrivateMethod ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: node.kind, 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property key and append ittfNode to `ret`
    if (node.key) {
        if (!node.key.type) {
            throw 'Node key has no type: ' + JSON.stringify(node);
        }
        format(ret, node.key, options);
    }
    else {
        throw new Error('AST-node-property key undefined: ' + JSON.stringify(node));
    }
    // s( kind, "method" | "get" | "set"
    console.log('node.static', node.static);
    if (!!node.static == true) {
        ret.children.push({
            tag: 'static', 
            children: [
                
            ]
        });
    }
    // process AST-node-property-collection decorators and append ittfNode(s) to `ret`
    if (node.decorators) {
        if (typeof node.decorators.length === 'undefined') {
            throw new Error('Property node.decorators must be an array');
        }
        var i, i_items=node.decorators, i_len=node.decorators.length, item;
        for (i=0; i<i_len; i++) {
            item = node.decorators[i];
            item.__parent = {
                name: 'decorators', 
                len: node.decorators.length
            };
            format(ret, item, options);
        }
    }
    // process AST-node-property-collection params and
    // embed its array of nodes in a new tag
    if (node.params) {
        if (typeof node.params.length === 'undefined') {
            throw new Error('Property node.params must be an array');
        }
        if (node.params.length > 0) {
            var tempparams = {
                tag: 'params', 
                children: [
                    
                ]
            };
            var i, i_items=node.params, i_len=node.params.length, item;
            for (i=0; i<i_len; i++) {
                item = node.params[i];
                item.__parent = {
                    name: 'params', 
                    len: node.params.length
                };
                format(tempparams, item, options);
            }
            ret.children.push(tempparams);
        }
    }
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    ret.tag = ret.tag == 'method' ? 'm' : ret.tag;
    processParams(ret);
    /**
        VIA
        replaceChildrenOfChildWhenText(ret, getChildPosByTag(ret, 'params'), 'param')*/
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ClassProperty
format.ClassProperty = function(parent, node, options) {
    console.log('node : ClassProperty ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'p', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Process AST-node-property key and
    // set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.key) {
        if (!node.key.type) {
            throw 'Node key has no type: ' + JSON.stringify(node);
        }
        var tempkey = {
            children: [
                
            ]
        };
        format(tempkey, node.key, options);
        /**
            if (tempkey .children.length > 0) {
                throw 'node.key must result zero node, returned: ' + tempkey.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempkey.children.length > 0) {
            appto.name = tempkey.children[0].name;
        }
        else {
            appto.name = tempkey.name;
        }
    }
    // process AST-node-property value and set it in a var
    var p_value = null;
    if (node.value) {
        p_value = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.value.type) {
            throw 'Node value has no type: ' + JSON.stringify(node);
        }
        format(p_value, node.value, options);
        if (p_value.children.length == 1) {
            if (!(p_value.children[0].isText || p_value.children[0].textified)) {
                p_value.tag = p_value.children[0].tag;
                p_value.name = p_value.children[0].name;
                p_value.source = p_value.children[0].source;
                p_value.children = p_value.children[0].children;
            }
            else {
                if (p_value.children[0].textified) {
                    p_value.textified = p_value.children[0].textified;
                }
                if (p_value.children[0].isText) {
                    p_value.isText = true;
                    p_value.name = p_value.children[0].name;
                    p_value.source = p_value.children[0].source;
                    p_value.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property value undefined: ' + JSON.stringify(node));
    }
    if (p_value.tag === '=>') {
        ret.tag = p_value.tag;
        ret.children = p_value.children;
    }
    else {
        if (node.computed) {
            ret.name = '[' + ret.name + ']';
        }
        if (isTextualNode(p_value)) {
            ret.name += ' = ' + getNodeText(p_value);
        }
        else {
            ret.children.push(p_value);
        }
    }
    console.log('node.static', node.static);
    if (!!node.static == true) {
        ret.children.push({
            tag: 'static', 
            children: [
                
            ]
        });
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ClassPrivateProperty
format.ClassPrivateProperty = function(parent, node, options) {
    console.log('node : ClassPrivateProperty ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'p', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property key and append ittfNode to `ret`
    if (node.key) {
        if (!node.key.type) {
            throw 'Node key has no type: ' + JSON.stringify(node);
        }
        format(ret, node.key, options);
    }
    else {
        throw new Error('AST-node-property key undefined: ' + JSON.stringify(node));
    }
    // process AST-node-property value and append ittfNode to `ret`
    if (node.value) {
        if (!node.value.type) {
            throw 'Node value has no type: ' + JSON.stringify(node);
        }
        format(ret, node.value, options);
    }
    else {
        throw new Error('AST-node-property value undefined: ' + JSON.stringify(node));
    }
    console.log('node.static', node.static);
    if (!!node.static == true) {
        ret.children.push({
            tag: 'static', 
            children: [
                
            ]
        });
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ClassDeclaration
format.ClassDeclaration = function(parent, node, options) {
    console.log('node : ClassDeclaration ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'class', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Process AST-node-property id and
    // set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.id) {
        if (!node.id.type) {
            throw 'Node id has no type: ' + JSON.stringify(node);
        }
        var tempid = {
            children: [
                
            ]
        };
        format(tempid, node.id, options);
        /**
            if (tempid .children.length > 0) {
                throw 'node.id must result zero node, returned: ' + tempid.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempid.children.length > 0) {
            appto.name = tempid.children[0].name;
        }
        else {
            appto.name = tempid.name;
        }
    }
    // process AST-node-property superClass and set it in a var
    var p_superClass = null;
    if (node.superClass) {
        p_superClass = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.superClass.type) {
            throw 'Node superClass has no type: ' + JSON.stringify(node);
        }
        format(p_superClass, node.superClass, options);
        if (p_superClass.children.length == 1) {
            if (!(p_superClass.children[0].isText || p_superClass.children[0].textified)) {
                p_superClass.tag = p_superClass.children[0].tag;
                p_superClass.name = p_superClass.children[0].name;
                p_superClass.source = p_superClass.children[0].source;
                p_superClass.children = p_superClass.children[0].children;
            }
            else {
                if (p_superClass.children[0].textified) {
                    p_superClass.textified = p_superClass.children[0].textified;
                }
                if (p_superClass.children[0].isText) {
                    p_superClass.isText = true;
                    p_superClass.name = p_superClass.children[0].name;
                    p_superClass.source = p_superClass.children[0].source;
                    p_superClass.children = [];
                }
            }
        }
    }
    if (p_superClass) {
        if (isTextualNode(p_superClass)) {
            ret.children.push({
                tag: 'super', 
                name: getNodeText(p_superClass), 
                children: [
                    
                ]
            });
        }
        else {
            throw new Error('Class. superClass must be textual: ' + JSON.stringify(node));
        }
    }
    // process AST-node-property-collection decorators and append ittfNode(s) to `ret`
    if (node.decorators) {
        if (typeof node.decorators.length === 'undefined') {
            throw new Error('Property node.decorators must be an array');
        }
        var i, i_items=node.decorators, i_len=node.decorators.length, item;
        for (i=0; i<i_len; i++) {
            item = node.decorators[i];
            item.__parent = {
                name: 'decorators', 
                len: node.decorators.length
            };
            format(ret, item, options);
        }
    }
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ClassExpression
format.ClassExpression = function(parent, node, options) {
    console.log('node : ClassExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'class', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property superClass and set it in a var
    var p_superClass = null;
    if (node.superClass) {
        p_superClass = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.superClass.type) {
            throw 'Node superClass has no type: ' + JSON.stringify(node);
        }
        format(p_superClass, node.superClass, options);
        if (p_superClass.children.length == 1) {
            if (!(p_superClass.children[0].isText || p_superClass.children[0].textified)) {
                p_superClass.tag = p_superClass.children[0].tag;
                p_superClass.name = p_superClass.children[0].name;
                p_superClass.source = p_superClass.children[0].source;
                p_superClass.children = p_superClass.children[0].children;
            }
            else {
                if (p_superClass.children[0].textified) {
                    p_superClass.textified = p_superClass.children[0].textified;
                }
                if (p_superClass.children[0].isText) {
                    p_superClass.isText = true;
                    p_superClass.name = p_superClass.children[0].name;
                    p_superClass.source = p_superClass.children[0].source;
                    p_superClass.children = [];
                }
            }
        }
    }
    if (p_superClass) {
        if (isTextualNode(p_superClass)) {
            ret.children.push({
                tag: 'super', 
                name: getNodeText(p_superClass), 
                children: [
                    
                ]
            });
        }
        else {
            throw new Error('Class. superClass must be textual: ' + JSON.stringify(node));
        }
    }
    // process AST-node-property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type: ' + JSON.stringify(node);
        }
        format(ret, node.body, options);
    }
    else {
        throw new Error('AST-node-property body undefined: ' + JSON.stringify(node));
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node MetaProperty
format.MetaProperty = function(parent, node, options) {
    console.log('node : MetaProperty ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'meta', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property meta and append ittfNode to `ret`
    if (node.meta) {
        if (!node.meta.type) {
            throw 'Node meta has no type: ' + JSON.stringify(node);
        }
        format(ret, node.meta, options);
    }
    else {
        throw new Error('AST-node-property meta undefined: ' + JSON.stringify(node));
    }
    // process AST-node-property property and append ittfNode to `ret`
    if (node.property) {
        if (!node.property.type) {
            throw 'Node property has no type: ' + JSON.stringify(node);
        }
        format(ret, node.property, options);
    }
    else {
        throw new Error('AST-node-property property undefined: ' + JSON.stringify(node));
    }
    var got_text_2 = false;
    if (isChildrenCount(ret, 2)) {
        if ((ret.children[0].textified || ret.children[0].isText) && (ret.children[1].textified || ret.children[1].isText)) {
            var c1 = ret.children[0].textified || ret.children[0].name;
            var c2 = ret.children[1].textified || ret.children[1].name;
            ret.name = c1 + '.' + c2;
            ret.textified = ret.name;
            ret.children = [];
            got_text_2 = true;
            got_text_2 = true;
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ModuleDeclaration
format.ModuleDeclaration = function(parent, node, options) {
    console.log('node : ModuleDeclaration ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'module', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A module `import` or `export` declaration.
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ImportDeclaration
format.ImportDeclaration = function(parent, node, options) {
    console.log('node : ImportDeclaration ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'import', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property-collection specifiers and append ittfNode(s) to `ret`
    if (node.specifiers) {
        if (typeof node.specifiers.length === 'undefined') {
            throw new Error('Property node.specifiers must be an array');
        }
        var i, i_items=node.specifiers, i_len=node.specifiers.length, item;
        for (i=0; i<i_len; i++) {
            item = node.specifiers[i];
            item.__parent = {
                name: 'specifiers', 
                len: node.specifiers.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection specifiers undefined: ' + JSON.stringify(node));
    }
    var p_source = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.source) {
        if (!node.source.type) {
            throw 'Node source has no type: ' + JSON.stringify(node);
        }
        format(p_source, node.source, options);
        p_source.tag = 'from';
        ret.children.push(p_source);
        if (p_source.children.length == 1) {
            console.log('*** f_p_tag source children[0].textified', p_source.children[0].textified);
            console.log('*** f_p_tag source children[0].isText', p_source.children[0].isText);
            console.log('*** f_p_tag source children[0].name', p_source.children[0].name);
            if (p_source.children[0].textified) {
                p_source.textified = p_source.children[0].textified;
            }
            if (p_source.children[0].isText) {
                p_source.isText = true;
                p_source.name = p_source.children[0].name;
                p_source.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property source/from not managed by f_p_tag');
            }
        */
    }
    // An import declaration, e.g., `import foo from "mod"`.
    //
    var xdefault = getChildByTag(ret, 'default');
    if (xdefault) {
        ret.name = xdefault.name;
        removeChildByTag(ret, 'default');
    }
    if (ret.children.length == 1 && ret.children[0].tag === 'from') {
        if (ret.name && ret.name.length > 0) {
            ret.name += ' from';
        }
        ret.name += ' '	+ ret.children[0].name;
        removeChildByTag(ret, 'from');
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ImportSpecifier
format.ImportSpecifier = function(parent, node, options) {
    console.log('node : ImportSpecifier ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '@', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Process AST-node-property imported and
    // set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.imported) {
        if (!node.imported.type) {
            throw 'Node imported has no type: ' + JSON.stringify(node);
        }
        var tempimported = {
            children: [
                
            ]
        };
        format(tempimported, node.imported, options);
        /**
            if (tempimported .children.length > 0) {
                throw 'node.imported must result zero node, returned: ' + tempimported.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempimported.children.length > 0) {
            appto.name = tempimported.children[0].name;
        }
        else {
            appto.name = tempimported.name;
        }
    }
    // f_p( local, true, Identifier
    // An imported variable binding, e.g., `{foo}` in `import {foo} from "mod"` or `{foo as bar}` in `import {foo as bar} from "mod"`. The `imported` field refers to the name of the export imported from the module. The `local` field refers to the binding imported into the local module scope. If it is a basic named import, such as in `import {foo} from "mod"`, both `imported` and `local` are equivalent `Identifier` nodes in this case an `Identifier` node representing `foo`. If it is an aliased import, such as in `import {foo as bar} from "mod"`, the `imported` field is an `Identifier` node representing `foo`, and the `local` field is an `Identifier` node representing `bar`.
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ImportDefaultSpecifier
format.ImportDefaultSpecifier = function(parent, node, options) {
    console.log('node : ImportDefaultSpecifier ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'default', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Process AST-node-property local and
    // set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.local) {
        if (!node.local.type) {
            throw 'Node local has no type: ' + JSON.stringify(node);
        }
        var templocal = {
            children: [
                
            ]
        };
        format(templocal, node.local, options);
        /**
            if (templocal .children.length > 0) {
                throw 'node.local must result zero node, returned: ' + templocal.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (templocal.children.length > 0) {
            appto.name = templocal.children[0].name;
        }
        else {
            appto.name = templocal.name;
        }
    }
    // A default import specifier, e.g., `foo` in `import foo from "mod.js"`.
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ImportNamespaceSpecifier
format.ImportNamespaceSpecifier = function(parent, node, options) {
    console.log('node : ImportNamespaceSpecifier ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'as', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property local and append ittfNode to `ret`
    if (node.local) {
        if (!node.local.type) {
            throw 'Node local has no type: ' + JSON.stringify(node);
        }
        format(ret, node.local, options);
    }
    else {
        throw new Error('AST-node-property local undefined: ' + JSON.stringify(node));
    }
    // A namespace import specifier, e.g., `* as foo` in `import * as foo from "mod.js"`.
    console.log('get_text_from_1_children', isChildrenCount(ret, 1));
    var got_text_1 = false;
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified || ret.children[0].isText) {
            var c1 = ret.children[0].textified || ret.children[0].name;
            ret.name = c1;
            ret.textified = ret.name;
            ret.children = [];
            got_text_1 = true;
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ExportNamedDeclaration
format.ExportNamedDeclaration = function(parent, node, options) {
    console.log('node : ExportNamedDeclaration ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'export', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property declaration and append ittfNode to `ret`
    if (node.declaration) {
        if (!node.declaration.type) {
            throw 'Node declaration has no type: ' + JSON.stringify(node);
        }
        format(ret, node.declaration, options);
    }
    // process AST-node-property-collection specifiers and append ittfNode(s) to `ret`
    if (node.specifiers) {
        if (typeof node.specifiers.length === 'undefined') {
            throw new Error('Property node.specifiers must be an array');
        }
        var i, i_items=node.specifiers, i_len=node.specifiers.length, item;
        for (i=0; i<i_len; i++) {
            item = node.specifiers[i];
            item.__parent = {
                name: 'specifiers', 
                len: node.specifiers.length
            };
            format(ret, item, options);
        }
    }
    else {
        throw new Error('AST-node-property-collection specifiers undefined: ' + JSON.stringify(node));
    }
    var p_source = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.source) {
        if (!node.source.type) {
            throw 'Node source has no type: ' + JSON.stringify(node);
        }
        format(p_source, node.source, options);
        p_source.tag = 'from';
        ret.children.push(p_source);
        if (p_source.children.length == 1) {
            console.log('*** f_p_tag source children[0].textified', p_source.children[0].textified);
            console.log('*** f_p_tag source children[0].isText', p_source.children[0].isText);
            console.log('*** f_p_tag source children[0].name', p_source.children[0].name);
            if (p_source.children[0].textified) {
                p_source.textified = p_source.children[0].textified;
            }
            if (p_source.children[0].isText) {
                p_source.isText = true;
                p_source.name = p_source.children[0].name;
                p_source.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property source/from not managed by f_p_tag');
            }
        */
    }
    // An export named declaration, e.g., `export {foo, bar}`, `export {foo} from "mod"`, `export var foo = 1` or `export * as foo from "bar"`.
    // _Note, Having `declaration` populated with non-empty `specifiers` or non-null `source` results in an invalid state._
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ExportSpecifier
format.ExportSpecifier = function(parent, node, options) {
    console.log('node : ExportSpecifier ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '@', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property exported and append ittfNode to `ret`
    if (node.exported) {
        if (!node.exported.type) {
            throw 'Node exported has no type: ' + JSON.stringify(node);
        }
        format(ret, node.exported, options);
    }
    else {
        throw new Error('AST-node-property exported undefined: ' + JSON.stringify(node));
    }
    // Process AST-node-property local and
    // set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.local) {
        if (!node.local.type) {
            throw 'Node local has no type: ' + JSON.stringify(node);
        }
        var templocal = {
            children: [
                
            ]
        };
        format(templocal, node.local, options);
        /**
            if (templocal .children.length > 0) {
                throw 'node.local must result zero node, returned: ' + templocal.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (templocal.children.length > 0) {
            appto.name = templocal.children[0].name;
        }
        else {
            appto.name = templocal.name;
        }
    }
    // An exported variable binding, e.g., `{foo}` in `export {foo}` or `{bar as foo}` in `export {bar as foo}`. The `exported` field refers to the name exported in the module. The `local` field refers to the binding into the local module scope. If it is a basic named export, such as in `export {foo}`, both `exported` and `local` are equivalent `Identifier` nodes in this case an `Identifier` node representing `foo`. If it is an aliased export, such as in `export {bar as foo}`, the `exported` field is an `Identifier` node representing `foo`, and the `local` field is an `Identifier` node representing `bar`.
    if (ret.children[0].name !== ret.name) {
        ret.children[0].tag = 'as';
    }
    else {
        ret.children = [];
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ExportDefaultSpecifier
format.ExportDefaultSpecifier = function(parent, node, options) {
    console.log('node : ExportDefaultSpecifier ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'export-default', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property exported and set it in a var
    var p_exported = null;
    if (node.exported) {
        p_exported = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.exported.type) {
            throw 'Node exported has no type: ' + JSON.stringify(node);
        }
        format(p_exported, node.exported, options);
        if (p_exported.children.length == 1) {
            if (!(p_exported.children[0].isText || p_exported.children[0].textified)) {
                p_exported.tag = p_exported.children[0].tag;
                p_exported.name = p_exported.children[0].name;
                p_exported.source = p_exported.children[0].source;
                p_exported.children = p_exported.children[0].children;
            }
            else {
                if (p_exported.children[0].textified) {
                    p_exported.textified = p_exported.children[0].textified;
                }
                if (p_exported.children[0].isText) {
                    p_exported.isText = true;
                    p_exported.name = p_exported.children[0].name;
                    p_exported.source = p_exported.children[0].source;
                    p_exported.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property exported undefined: ' + JSON.stringify(node));
    }
    if (isTextualNode(p_exported)) {
        ret.name = getNodeText(p_exported);
    }
    else {
        ret.children.push(p_exported);
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ExportDefaultDeclaration
format.ExportDefaultDeclaration = function(parent, node, options) {
    console.log('node : ExportDefaultDeclaration ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'export-default', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // An export default declaration, e.g., `export default function () {}` or `export default 1`.
    /**
         process AST-node-property id and set it in a var
        var p_id = null;
        if (node.id) {
            p_id = {
                textified: null, 
                isText: false, 
                children: [
                    
                ]
            };
            if (!node.id.type) {
                throw 'Node id has no type: ' + JSON.stringify(node);
            }
            format(p_id, node.id, options);
            if (p_id.children.length == 1) {
                if (!(p_id.children[0].isText || p_id.children[0].textified)) {
                    p_id.tag = p_id.children[0].tag;
                    p_id.name = p_id.children[0].name;
                    p_id.source = p_id.children[0].source;
                    p_id.children = p_id.children[0].children;
                }
                else {
                    if (p_id.children[0].textified) {
                        p_id.textified = p_id.children[0].textified;
                    }
                    if (p_id.children[0].isText) {
                        p_id.isText = true;
                        p_id.name = p_id.children[0].name;
                        p_id.source = p_id.children[0].source;
                        p_id.children = [];
                    }
                }
            }
        }
        else {
            throw new Error('AST-node-property id undefined: ' + JSON.stringify(node));
        }
        ret.name = getNodeText(p_id)*/
    // process AST-node-property declaration and set it in a var
    var p_declaration = null;
    if (node.declaration) {
        p_declaration = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.declaration.type) {
            throw 'Node declaration has no type: ' + JSON.stringify(node);
        }
        format(p_declaration, node.declaration, options);
        if (p_declaration.children.length == 1) {
            if (!(p_declaration.children[0].isText || p_declaration.children[0].textified)) {
                p_declaration.tag = p_declaration.children[0].tag;
                p_declaration.name = p_declaration.children[0].name;
                p_declaration.source = p_declaration.children[0].source;
                p_declaration.children = p_declaration.children[0].children;
            }
            else {
                if (p_declaration.children[0].textified) {
                    p_declaration.textified = p_declaration.children[0].textified;
                }
                if (p_declaration.children[0].isText) {
                    p_declaration.isText = true;
                    p_declaration.name = p_declaration.children[0].name;
                    p_declaration.source = p_declaration.children[0].source;
                    p_declaration.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property declaration undefined: ' + JSON.stringify(node));
    }
    if (isTextualNode(p_declaration)) {
        ret.name = getNodeText(p_declaration);
    }
    else {
        ret.children.push(p_declaration);
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ExportNamespaceSpecifier
format.ExportNamespaceSpecifier = function(parent, node, options) {
    console.log('node : ExportNamespaceSpecifier ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'as', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property exported and set it in a var
    var p_exported = null;
    if (node.exported) {
        p_exported = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.exported.type) {
            throw 'Node exported has no type: ' + JSON.stringify(node);
        }
        format(p_exported, node.exported, options);
        if (p_exported.children.length == 1) {
            if (!(p_exported.children[0].isText || p_exported.children[0].textified)) {
                p_exported.tag = p_exported.children[0].tag;
                p_exported.name = p_exported.children[0].name;
                p_exported.source = p_exported.children[0].source;
                p_exported.children = p_exported.children[0].children;
            }
            else {
                if (p_exported.children[0].textified) {
                    p_exported.textified = p_exported.children[0].textified;
                }
                if (p_exported.children[0].isText) {
                    p_exported.isText = true;
                    p_exported.name = p_exported.children[0].name;
                    p_exported.source = p_exported.children[0].source;
                    p_exported.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property exported undefined: ' + JSON.stringify(node));
    }
    if (isTextualNode(p_exported)) {
        ret.name = getNodeText(p_exported);
    }
    else {
        ret.children.push(p_exported);
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node ExportAllDeclaration
format.ExportAllDeclaration = function(parent, node, options) {
    console.log('node : ExportAllDeclaration ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'export-all', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_source = {
        textified: null, 
        isText: false, 
        children: [
            
        ]
    };
    if (node.source) {
        if (!node.source.type) {
            throw 'Node source has no type: ' + JSON.stringify(node);
        }
        format(p_source, node.source, options);
        p_source.tag = 'from';
        ret.children.push(p_source);
        if (p_source.children.length == 1) {
            console.log('*** f_p_tag source children[0].textified', p_source.children[0].textified);
            console.log('*** f_p_tag source children[0].isText', p_source.children[0].isText);
            console.log('*** f_p_tag source children[0].name', p_source.children[0].name);
            if (p_source.children[0].textified) {
                p_source.textified = p_source.children[0].textified;
            }
            if (p_source.children[0].isText) {
                p_source.isText = true;
                p_source.name = p_source.children[0].name;
                p_source.children = [];
            }
        }
        /**
            TODO VIA
            else {
                throw new Error('AST-property source/from not managed by f_p_tag');
            }
        */
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node CommentBlock
format.CommentBlock = function(parent, node, options) {
};
// process AST node CommentLine
format.CommentLine = function(parent, node, options) {
};
// process AST node JSXAttribute
format.JSXAttribute = function(parent, node, options) {
    console.log('node : JSXAttribute ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '@', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property name and set it in a var
    var p_name = null;
    if (node.name) {
        p_name = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.name.type) {
            throw 'Node name has no type: ' + JSON.stringify(node);
        }
        format(p_name, node.name, options);
        if (p_name.children.length == 1) {
            if (!(p_name.children[0].isText || p_name.children[0].textified)) {
                p_name.tag = p_name.children[0].tag;
                p_name.name = p_name.children[0].name;
                p_name.source = p_name.children[0].source;
                p_name.children = p_name.children[0].children;
            }
            else {
                if (p_name.children[0].textified) {
                    p_name.textified = p_name.children[0].textified;
                }
                if (p_name.children[0].isText) {
                    p_name.isText = true;
                    p_name.name = p_name.children[0].name;
                    p_name.source = p_name.children[0].source;
                    p_name.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property name undefined: ' + JSON.stringify(node));
    }
    // process AST-node-property value and set it in a var
    var p_value = null;
    if (node.value) {
        p_value = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.value.type) {
            throw 'Node value has no type: ' + JSON.stringify(node);
        }
        format(p_value, node.value, options);
        if (p_value.children.length == 1) {
            if (!(p_value.children[0].isText || p_value.children[0].textified)) {
                p_value.tag = p_value.children[0].tag;
                p_value.name = p_value.children[0].name;
                p_value.source = p_value.children[0].source;
                p_value.children = p_value.children[0].children;
            }
            else {
                if (p_value.children[0].textified) {
                    p_value.textified = p_value.children[0].textified;
                }
                if (p_value.children[0].isText) {
                    p_value.isText = true;
                    p_value.name = p_value.children[0].name;
                    p_value.source = p_value.children[0].source;
                    p_value.children = [];
                }
            }
        }
    }
    if (isTextualNode(p_name)) {
        ret.name = getNodeText(p_name);
    }
    else {
        throw new Error('JSXAttribute.name must be textual:' + JSON.stringify(node));
    }
    if (p_value) {
        if (isTextualNode(p_value)) {
            ret.name += ' ' + getNodeText(p_value);
        }
        else {
            ret.children.push(p_value);
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node JSXClosingElement
format.JSXClosingElement = function(parent, node, options) {
    console.log('node : JSXClosingElement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'jsx-close', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // name JSXIdentifier | JSXMemberExpression
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node JSXElement
format.JSXElement = function(parent, node, options) {
    console.log('node : JSXElement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'jsx-element', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property openingElement and set it in a var
    var p_openingElement = null;
    if (node.openingElement) {
        p_openingElement = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.openingElement.type) {
            throw 'Node openingElement has no type: ' + JSON.stringify(node);
        }
        format(p_openingElement, node.openingElement, options);
        if (p_openingElement.children.length == 1) {
            if (!(p_openingElement.children[0].isText || p_openingElement.children[0].textified)) {
                p_openingElement.tag = p_openingElement.children[0].tag;
                p_openingElement.name = p_openingElement.children[0].name;
                p_openingElement.source = p_openingElement.children[0].source;
                p_openingElement.children = p_openingElement.children[0].children;
            }
            else {
                if (p_openingElement.children[0].textified) {
                    p_openingElement.textified = p_openingElement.children[0].textified;
                }
                if (p_openingElement.children[0].isText) {
                    p_openingElement.isText = true;
                    p_openingElement.name = p_openingElement.children[0].name;
                    p_openingElement.source = p_openingElement.children[0].source;
                    p_openingElement.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property openingElement undefined: ' + JSON.stringify(node));
    }
    // f_p( closingElement, true, JSXClosingElement
    // process AST-node-property-collection children and
    // embed its array of nodes in a temp var
    if (node.children) {
        if (typeof node.children.length === 'undefined') {
            throw new Error('Property node.children must be an array');
        }
        var p_children = {
            tag: 'true', 
            children: [
                
            ]
        };
        var i, i_items=node.children, i_len=node.children.length, item;
        for (i=0; i<i_len; i++) {
            item = node.children[i];
            item.__parent = {
                name: 'children', 
                len: node.children.length
            };
            format(p_children, item, options);
        }
    }
    var char = p_openingElement.name[0];
    if (char == char.toUpperCase()) {
        ret.tag = '< ' + p_openingElement.name;
    }
    else {
        ret.tag = p_openingElement.name;
    }
    ret.children = p_openingElement.children;
    var i, i_items=p_children.children, i_len=p_children.children.length, item;
    for (i=0; i<i_len; i++) {
        item = p_children.children[i];
        if (!(item.tag === '+' && item.name.trim().length == 0)) {
            ret.children.push(item);
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node JSXEmptyExpression
format.JSXEmptyExpression = function(parent, node, options) {
    console.log('node : JSXEmptyExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    ret.tag = '+';
    ret.name = '{}';
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node JSXExpressionContainer
format.JSXExpressionContainer = function(parent, node, options) {
    console.log('node : JSXExpressionContainer ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property expression and set it in a var
    var p_expression = null;
    if (node.expression) {
        p_expression = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.expression.type) {
            throw 'Node expression has no type: ' + JSON.stringify(node);
        }
        format(p_expression, node.expression, options);
        if (p_expression.children.length == 1) {
            if (!(p_expression.children[0].isText || p_expression.children[0].textified)) {
                p_expression.tag = p_expression.children[0].tag;
                p_expression.name = p_expression.children[0].name;
                p_expression.source = p_expression.children[0].source;
                p_expression.children = p_expression.children[0].children;
            }
            else {
                if (p_expression.children[0].textified) {
                    p_expression.textified = p_expression.children[0].textified;
                }
                if (p_expression.children[0].isText) {
                    p_expression.isText = true;
                    p_expression.name = p_expression.children[0].name;
                    p_expression.source = p_expression.children[0].source;
                    p_expression.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property expression undefined: ' + JSON.stringify(node));
    }
    if (isTextualNode(p_expression)) {
        ret.tag = '+';
        ret.name = '{' + getNodeText(p_expression) + '}';
        ret.textified = ret.name;
    }
    else {
        ret.tag = '{';
        ret.children.push(p_expression);
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node JSXSpreadChild
format.JSXSpreadChild = function(parent, node, options) {
    console.log('node : JSXSpreadChild ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property expression and set it in a var
    var p_expression = null;
    if (node.expression) {
        p_expression = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.expression.type) {
            throw 'Node expression has no type: ' + JSON.stringify(node);
        }
        format(p_expression, node.expression, options);
        if (p_expression.children.length == 1) {
            if (!(p_expression.children[0].isText || p_expression.children[0].textified)) {
                p_expression.tag = p_expression.children[0].tag;
                p_expression.name = p_expression.children[0].name;
                p_expression.source = p_expression.children[0].source;
                p_expression.children = p_expression.children[0].children;
            }
            else {
                if (p_expression.children[0].textified) {
                    p_expression.textified = p_expression.children[0].textified;
                }
                if (p_expression.children[0].isText) {
                    p_expression.isText = true;
                    p_expression.name = p_expression.children[0].name;
                    p_expression.source = p_expression.children[0].source;
                    p_expression.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property expression undefined: ' + JSON.stringify(node));
    }
    ret.tag = p_expression.tag;
    ret.name = '...' + p_expression.name;
    ret.children = p_expression.children;
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node JSXIdentifier
format.JSXIdentifier = function(parent, node, options) {
    console.log('node : JSXIdentifier ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'jsx-ident', 
        name: '', 
        isText: true, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // log 't/name.node.name, value: ', node.name, '
    if (typeof node.name !== 'undefined') {
        ret.name = node.name.toString();
    }
    // log 't/name ittf.ret', ret
    if (ret != null) {
        ret.textified = ret.name;
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node JSXMemberExpression
format.JSXMemberExpression = function(parent, node, options) {
    console.log('node : JSXMemberExpression ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property object and append ittfNode to `ret`
    if (node.object) {
        if (!node.object.type) {
            throw 'Node object has no type: ' + JSON.stringify(node);
        }
        format(ret, node.object, options);
    }
    else {
        throw new Error('AST-node-property object undefined: ' + JSON.stringify(node));
    }
    // process AST-node-property property and append ittfNode to `ret`
    if (node.property) {
        if (!node.property.type) {
            throw 'Node property has no type: ' + JSON.stringify(node);
        }
        format(ret, node.property, options);
    }
    else {
        throw new Error('AST-node-property property undefined: ' + JSON.stringify(node));
    }
    var got_text_2 = false;
    if (isChildrenCount(ret, 2)) {
        if ((ret.children[0].textified || ret.children[0].isText) && (ret.children[1].textified || ret.children[1].isText)) {
            var c1 = ret.children[0].textified || ret.children[0].name;
            var c2 = ret.children[1].textified || ret.children[1].name;
            ret.name = c1 + '.' + c2;
            ret.textified = ret.name;
            ret.children = [];
            got_text_2 = true;
            got_text_2 = true;
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node JSXNamespacedName
format.JSXNamespacedName = function(parent, node, options) {
    console.log('node : JSXNamespacedName ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // namespace JSXIdentifier
    // name JSXIdentifier
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node JSXOpeningElement
format.JSXOpeningElement = function(parent, node, options) {
    console.log('node : JSXOpeningElement ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'jsx-open', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property name and set it in a var
    var p_name = null;
    if (node.name) {
        p_name = {
            textified: null, 
            isText: false, 
            children: [
                
            ]
        };
        if (!node.name.type) {
            throw 'Node name has no type: ' + JSON.stringify(node);
        }
        format(p_name, node.name, options);
        if (p_name.children.length == 1) {
            if (!(p_name.children[0].isText || p_name.children[0].textified)) {
                p_name.tag = p_name.children[0].tag;
                p_name.name = p_name.children[0].name;
                p_name.source = p_name.children[0].source;
                p_name.children = p_name.children[0].children;
            }
            else {
                if (p_name.children[0].textified) {
                    p_name.textified = p_name.children[0].textified;
                }
                if (p_name.children[0].isText) {
                    p_name.isText = true;
                    p_name.name = p_name.children[0].name;
                    p_name.source = p_name.children[0].source;
                    p_name.children = [];
                }
            }
        }
    }
    else {
        throw new Error('AST-node-property name undefined: ' + JSON.stringify(node));
    }
    // selfClosing boolean
    // process AST-node-property-collection attributes and
    // embed its array of nodes in a temp var
    if (node.attributes) {
        if (typeof node.attributes.length === 'undefined') {
            throw new Error('Property node.attributes must be an array');
        }
        var p_attributes = {
            tag: 'attributes', 
            children: [
                
            ]
        };
        var i, i_items=node.attributes, i_len=node.attributes.length, item;
        for (i=0; i<i_len; i++) {
            item = node.attributes[i];
            item.__parent = {
                name: 'attributes', 
                len: node.attributes.length
            };
            format(p_attributes, item, options);
        }
    }
    // process AST-node-property-collection parameters and
    // embed its array of nodes in a temp var
    if (node.parameters) {
        if (typeof node.parameters.length === 'undefined') {
            throw new Error('Property node.parameters must be an array');
        }
        var p_parameters = {
            tag: 'parameters', 
            children: [
                
            ]
        };
        var i, i_items=node.parameters, i_len=node.parameters.length, item;
        for (i=0; i<i_len; i++) {
            item = node.parameters[i];
            item.__parent = {
                name: 'parameters', 
                len: node.parameters.length
            };
            format(p_parameters, item, options);
        }
    }
    if (isTextualNode(p_name)) {
        ret.name = getNodeText(p_name);
    }
    else {
        throw new Error('JSXOpeningElement.name must be textual:' + JSON.stringify(node));
    }
    var i, i_items=p_attributes.children, i_len=p_attributes.children.length, item;
    for (i=0; i<i_len; i++) {
        item = p_attributes.children[i];
        ret.children.push(item);
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node JSXSpreadAttribute
format.JSXSpreadAttribute = function(parent, node, options) {
    console.log('node : JSXSpreadAttribute ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '@', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process AST-node-property argument and append ittfNode to `ret`
    if (node.argument) {
        if (!node.argument.type) {
            throw 'Node argument has no type: ' + JSON.stringify(node);
        }
        format(ret, node.argument, options);
    }
    else {
        throw new Error('AST-node-property argument undefined: ' + JSON.stringify(node));
    }
    console.log('get_text_from_1_children', isChildrenCount(ret, 1));
    var got_text_1 = false;
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified || ret.children[0].isText) {
            var c1 = ret.children[0].textified || ret.children[0].name;
            ret.name = '{...' + c1 + "}";
            ret.textified = ret.name;
            ret.children = [];
            got_text_1 = true;
        }
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node JSXText
format.JSXText = function(parent, node, options) {
    console.log('node : JSXText ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: '+', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    if (node.value.trim().length == 0 || node.value === '\n') {
        ret = null;
    }
    else {
        ret.name = verify.replaceAll(node.value, '\n', '\\n');
    }
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node JSXFragment
format.JSXFragment = function(parent, node, options) {
    console.log('node : JSXFragment ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'fragment', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // openingFragment JSXOpeningFragment
    // closingFragment JSXClosingFragment
    // children JSXText | JSXExpressionContainer | JSXSpreadChild | JSXElement | JSXFragment
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node JSXOpeningFragment
format.JSXOpeningFragment = function(parent, node, options) {
    console.log('node : JSXOpeningFragment ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'fragment-open', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // aliases: ["JSX", "Immutable"],
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
// process AST node JSXClosingFragment
format.JSXClosingFragment = function(parent, node, options) {
    console.log('node : JSXClosingFragment ----------------------------------------- parent ittf tag : ', parent.tag);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (['type', 'start', 'end', 'loc'].indexOf(item) < 0) {
            if (verify.isNotEmpty(node[item])) {
                // log 'property', item, node[item]
            }
            else {
                // log 'property', item
            }
        }
    }
    var ret = {
        tag: 'fragment-close', 
        name: '', 
        isText: false, 
        textified: null, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // aliases: ["JSX", "Immutable"]
    if (ret != null) {
        // log '### add ', ret.tag , 'to', parent.tag
        processLeadingComments(node, parent);
        parent.children.push(ret);
    }
};
var md = module.exports = {};
function processLeadingComments(node, ittfNode) {
    if (verify.isArray(node.leadingComments) && node.leadingComments.length > 0) {
        var i, i_items=node.leadingComments, i_len=node.leadingComments.length, item;
        for (i=0; i<i_len; i++) {
            item = node.leadingComments[i];
            if (item.type === 'CommentLine') {
                ittfNode.children.push({
                    tag: '#', 
                    name: item.value, 
                    children: [
                        
                    ]
                });
            }
            else if (item.type === 'CommentBlock') {
                var ss = item.value.split(/\r\n|\r|\n/);
                var temp = {
                    tag: '#', 
                    children: [
                        
                    ]
                };
                var j, j_items=ss, j_len=ss.length, s;
                for (j=0; j<j_len; j++) {
                    s = ss[j];
                    temp.children.push({
                        tag: '#', 
                        name: s, 
                        children: [
                            
                        ]
                    });
                }
                ittfNode.children.push(temp);
            }
        }
    }
}
function processParams(ittfNode) {
    var pos = getChildPosByTag(ittfNode, 'params');
    var temp = [];
    var i, i_items=ittfNode.children, i_len=ittfNode.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ittfNode.children[i];
        if (pos == i) {
            var j, j_items=item.children, j_len=item.children.length, p;
            for (j=0; j<j_len; j++) {
                p = item.children[j];
                console.log('+++++++++++++++++++++++++++++++++++ processParams. p.tag', p.tag);
                if (p.tag !== '{') {
                    if (isTextualNode(p)) {
                        p.tag = 'param';
                    }
                    /**
                        else {
                            throw new Error('processParams.error. Param must be a textual or an ObjectPattern. Node:' + JSON.stringify(ittfNode));
                        }
                    */
                }
                temp.push(p);
            }
        }
        else {
            temp.push(item);
        }
    }
    ittfNode.children = temp;
}
function getNodeText(ittfNode) {
    return ittfNode.textified || ittfNode.name;
}
function isTextualNode(ittfNode) {
    return ittfNode && (ittfNode.isText || ittfNode.textified);
}
function isTextualChildByTag(ittfNode, tag) {
    var item = getChildByTag(ittfNode, tag);
    return item && (item.isText || item.textified);
}
function replaceChildTag(ittfNode, oldTag, newTag) {
    var item = getChildByTag(ittfNode, oldTag);
    item.tag = newTag;
}
function removeChildByTag(ittfNode, tag) {
    var temp = [];
    var i, i_items=ittfNode.children, i_len=ittfNode.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ittfNode.children[i];
        if (item.tag !== tag) {
            temp.push(item);
        }
    }
    ittfNode.children = temp;
}
function getChildByTag(ittfNode, tag) {
    var i, i_items=ittfNode.children, i_len=ittfNode.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ittfNode.children[i];
        if (item.tag === tag) {
            return item;
        }
    }
    return null;
}
function getChildPosByTag(ittfNode, tag) {
    var i, i_items=ittfNode.children, i_len=ittfNode.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ittfNode.children[i];
        if (item.tag === tag) {
            return i;
        }
    }
    return -1;
}
function replaceChildrenOfChildWhenText(ittfNode, childPos, textTag) {
    if (childPos < 0) {
        return ;
    }
    ittfNode.children = replaceItemInColl(ittfNode.children, childPos, textifyChildren(ittfNode.children[childPos], textTag));
}
function replaceItemInColl(coll, pos, replacers) {
    var ret = [];
    var i, i_items=coll, i_len=coll.length, item;
    for (i=0; i<i_len; i++) {
        item = coll[i];
        if (pos == i) {
            var j, j_items=replacers, j_len=replacers.length, repl;
            for (j=0; j<j_len; j++) {
                repl = replacers[j];
                ret.push(repl);
            }
        }
        else {
            ret.push(item);
        }
    }
    return ret;
}
function textifyChildren(ittfNode, tag) {
    var ret = [];
    var i, i_items=ittfNode.children, i_len=ittfNode.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ittfNode.children[i];
        if (item.isText || item.textified) {
            console.log('@@@@@@@ item.tag.isText', item.tag, item.isText);
            ret.push({
                tag: tag, 
                name: item.isText ? item.name : item.textified, 
                textified: item.isText ? item.name : item.textified, 
                children: [
                    
                ]
            });
        }
        else {
            ret.push(item);
        }
    }
    // log '@@@@@@@@@@@@@@@ textifyChildren', ret
    return ret;
}
function setTextList(ittfNode, sep) {
    var sb = [];
    var i, i_items=ittfNode.children, i_len=ittfNode.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ittfNode.children[i];
        console.log('setTextList', item.tag, item.isText, item.textified);
        if (item.isText) {
            sb.push(item.name);
        }
        else if (item.textified) {
            sb.push(item.textified);
        }
        else {
            return false;
        }
    }
    ittfNode.textified = sb.join(sep);
    ittfNode.children = [];
    return true;
}
function getTextList(ittfNode, sep) {
    var sb = [];
    var i, i_items=ittfNode.children, i_len=ittfNode.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ittfNode.children[i];
        if (item.isText) {
            sb.push(item.name);
        }
        else if (item.textified) {
            sb.push(item.textified);
        }
        else {
            // log 'getTextList failed ***************', item
            return null;
        }
    }
    return sb.join(sep);
}
function setNameFromChildByTag(ittfNode, tag, forceText) {
    var i, i_items=ittfNode.children, i_len=ittfNode.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ittfNode.children[i];
        if (item.tag === tag) {
            if (forceText) {
                console.log('...................setNameFromChildByTag', item);
            }
            if (item.isText) {
                ittfNode.name = item.name;
                ittfNode.children.splice(i, 1);
                return ;
            }
            if (forceText && item.textified) {
                ittfNode.name = item.textified;
                ittfNode.children.splice(i, 1);
                return ;
            }
        }
    }
}
function objectDeclareKey(key) {
    return key.indexOf(' ') > 0 ? '["' + key + '"]' : key;
}
function replaceWithSingleChild(ittfNode, childTag, limit) {
    if (isChildrenCount(ittfNode, 1)) {
        var childTag = ittfNode.children[0].tag;
        var testTag = limit ? childTag.substr(0, limit) : childTag;
        if (testTag === childTag) {
            ittfNode.tag = ittfNode.children[0].tag;
            ittfNode.name = ittfNode.children[0].name;
            ittfNode.textified = ittfNode.children[0].textified;
            ittfNode.children = ittfNode.children[0].children;
            return true;
        }
    }
    return false;
}
function isChildrenCount(ittfNode, count) {
    return ittfNode.children && ittfNode.children.length == count;
}
function isChildrenCountGreaterEqualThen(ittfNode, count) {
    return ittfNode.children && ittfNode.children.length >= count;
}
md.parse = function(input, options) {
    return parser.parse(input, {
            sourceType: 'module', 
            plugins: [
                "jsx", 
                "flow", 
                "objectRestSpread", 
                "classProperties", 
                "doExpressions", 
                ['decorators', { decoratorsBeforeExport: false }], 
                "classProperties", 
                "classPrivateProperties", 
                "classPrivateMethods", 
                "exportDefaultFrom", 
                "exportNamespaceFrom", 
                "asyncGenerators", 
                "functionBind", 
                "functionSent", 
                "dynamicImport", 
                "numericSeparator", 
                "optionalChaining", 
                "importMeta", 
                "bigInt", 
                "optionalCatchBinding", 
                "throwExpressions", 
                "nullishCoalescingOperator"
            ]
        });
};
md.getCodeAST = function(input, options, callback) {
    options = options || {};
    options.input = input;
    options.stack = [];
    options.formatTextNodes = [];
    var babelOptions = options.babel || {};
    var syntax;
    try {
        syntax = md.parse(input, babelOptions);
    } 
    catch (ex) {
        return callback(ex);
    } 
    return callback(null, cleanBabel.cleanAst(syntax));
};
md.getWizziIttf = function(input, options, callback) {
    console.log('options', options);
    options = options || {};
    options.input = input;
    options.stack = [];
    options.formatTextNodes = [];
    var startTime = Date.now();
    var babelOptions = options.babel || {};
    var syntax = md.parse(input, babelOptions);
    console.log('Parsed in ' + (Date.now() - startTime) + ' ms');
    options.starter = true;
    var root = {
        tag: 'module', 
        children: [
            {
                tag: 'kind', 
                name: 'react', 
                children: [
                    
                ]
            }
        ]
    };
    format(root, syntax, options);
    // log "wizziTree", JSON.stringify(root, null, 2)
    var ittf = ittfwriter.stringify(root, { lang: 'js' });
    // log "wizziIttf\n" + ittf
    if (options.syntaxOutFile) {
        file.write(options.syntaxOutFile, JSON.stringify(cleanBabel.cleanAst(syntax), null, 2));
    }
    callback(null, ittf);
};
